This documentation is aimed at modders. It displays all traits with default values and developer commentary. Please do not edit it directly, but add new `[Desc("String")]` tags to the source code. This file has been automatically generated for version {DEV_VERSION} of OpenRA.

* [DeadBuildingState](#deadbuildingstate)
* [PoisonedByTiberium](#poisonedbytiberium)
* [TiberiumRefinery](#tiberiumrefinery)
* [SpawnViceroid](#spawnviceroid)
* [ProductionAirdrop](#productionairdrop)
* [WithRoof](#withroof)
* [WithCargo](#withcargo)
* [WithFire](#withfire)
* [IonCannonPower](#ioncannonpower)
* [PlayMusicOnMapLoad](#playmusiconmapload)
* [ResourceClaimLayer](#resourceclaimlayer)
* [RadarPings](#radarpings)
* [SmudgeLayer](#smudgelayer)
* [RallyPoint](#rallypoint)
* [PaletteFromFile](#palettefromfile)
* [ChatCommands](#chatcommands)
* [PlayerCommands](#playercommands)
* [DevCommands](#devcommands)
* [HelpCommand](#helpcommand)
* [Contrail](#contrail)
* [JamsMissiles](#jamsmissiles)
* [ProvidesRadar](#providesradar)
* [JamsRadar](#jamsradar)
* [ThrowsShrapnel](#throwsshrapnel)
* [FogPaletteFromR8](#fogpalettefromr8)
* [ChooseBuildTabOnSelect](#choosebuildtabonselect)
* [D2kResourceLayer](#d2kresourcelayer)
* [PaletteFromScaledPalette](#palettefromscaledpalette)
* [PaletteFromR8](#palettefromr8)
* [DamagedWithoutFoundation](#damagedwithoutfoundation)
* [WithProductionOverlay](#withproductionoverlay)
* [WithDeliveryOverlay](#withdeliveryoverlay)
* [WithCrumbleOverlay](#withcrumbleoverlay)
* [WithBuildingPlacedOverlay](#withbuildingplacedoverlay)
* [WithDockingOverlay](#withdockingoverlay)
* [ProximityCaptor](#proximitycaptor)
* [Reservable](#reservable)
* [AutoHeal](#autoheal)
* [CreateMPPlayers](#creatempplayers)
* [DisguiseToolTip](#disguisetooltip)
* [Disguise](#disguise)
* [IgnoresDisguise](#ignoresdisguise)
* [Turreted](#turreted)
* [GainsStatUpgrades](#gainsstatupgrades)
* [RepairsUnits](#repairsunits)
* [BridgeLayer](#bridgelayer)
* [Production](#production)
* [Exit](#exit)
* [AutoTarget](#autotarget)
* [AutoTargetIgnore](#autotargetignore)
* [HarvesterHuskModifier](#harvesterhuskmodifier)
* [TransformOnPassenger](#transformonpassenger)
* [CrateSpawner](#cratespawner)
* [CashTrickler](#cashtrickler)
* [DisableUpgrade](#disableupgrade)
* [TakeCover](#takecover)
* [DetectCloaked](#detectcloaked)
* [PrimaryBuilding](#primarybuilding)
* [WaterPaletteRotation](#waterpaletterotation)
* [TimedUpgradeBar](#timedupgradebar)
* [RenderRangeCircle](#renderrangecircle)
* [EngineerRepair](#engineerrepair)
* [EngineerRepairable](#engineerrepairable)
* [SpawnActorPower](#spawnactorpower)
* [ChronoshiftPower](#chronoshiftpower)
* [GpsWatcher](#gpswatcher)
* [GpsPower](#gpspower)
* [SupportPowerChargeBar](#supportpowerchargebar)
* [SupportPowerManager](#supportpowermanager)
* [AirstrikePower](#airstrikepower)
* [GrantUpgradePower](#grantupgradepower)
* [NukePower](#nukepower)
* [ParatroopersPower](#paratrooperspower)
* [Cloneable](#cloneable)
* [FreeActor](#freeactor)
* [TargetableSubmarine](#targetablesubmarine)
* [AttackBomber](#attackbomber)
* [RenderDetectionCircle](#renderdetectioncircle)
* [PortableChrono](#portablechrono)
* [GainsExperience](#gainsexperience)
* [EjectOnDeath](#ejectondeath)
* [StrategicPoint](#strategicpoint)
* [StrategicVictoryConditions](#strategicvictoryconditions)
* [ShroudRenderer](#shroudrenderer)
* [Captures](#captures)
* [MenuPaletteEffect](#menupaletteeffect)
* [ConquestVictoryConditions](#conquestvictoryconditions)
* [MustBeDestroyed](#mustbedestroyed)
* [GlobalUpgradable](#globalupgradable)
* [ResourceLayer](#resourcelayer)
* [PathfinderDebugOverlay](#pathfinderdebugoverlay)
* [BuildableTerrainLayer](#buildableterrainlayer)
* [DomainIndex](#domainindex)
* [Armament](#armament)
* [OreRefinery](#orerefinery)
* [ExternalCapturableBar](#externalcapturablebar)
* [Demolishable](#demolishable)
* [ClonesProducedUnits](#clonesproducedunits)
* [Husk](#husk)
* [StoresResources](#storesresources)
* [SelfHealing](#selfhealing)
* [LimitedAmmo](#limitedammo)
* [BelowUnits](#belowunits)
* [TargetableUnit](#targetableunit)
* [MPStartUnits](#mpstartunits)
* [ProximityCapturable](#proximitycapturable)
* [BlocksBullets](#blocksbullets)
* [ActorGroupProxy](#actorgroupproxy)
* [HarvesterAttackNotifier](#harvesterattacknotifier)
* [GlobalUpgradeManager](#globalupgrademanager)
* [ProductionQueue](#productionqueue)
* [TechTree](#techtree)
* [AllyRepair](#allyrepair)
* [PlaceBuilding](#placebuilding)
* [BaseAttackNotifier](#baseattacknotifier)
* [PlayerStatistics](#playerstatistics)
* [UpdatesPlayerStatistics](#updatesplayerstatistics)
* [ClassicProductionQueue](#classicproductionqueue)
* [ProvidesCustomPrerequisite](#providescustomprerequisite)
* [PlaceBeacon](#placebeacon)
* [ProvidesTechPrerequisite](#providestechprerequisite)
* [MissionObjectives](#missionobjectives)
* [ObjectivesPanel](#objectivespanel)
* [Sellable](#sellable)
* [Valued](#valued)
* [DisabledOverlay](#disabledoverlay)
* [UpgradeOverlay](#upgradeoverlay)
* [FrozenUnderFog](#frozenunderfog)
* [HiddenUnderFog](#hiddenunderfog)
* [AppearsOnRadar](#appearsonradar)
* [PaletteFromRGBA](#palettefromrgba)
* [ParaDrop](#paradrop)
* [Burns](#burns)
* [Cloak](#cloak)
* [LightPaletteRotator](#lightpaletterotator)
* [EmitInfantryOnSell](#emitinfantryonsell)
* [Crate](#crate)
* [DeathSounds](#deathsounds)
* [AttackTurreted](#attackturreted)
* [AttackPopupTurreted](#attackpopupturreted)
* [AttackGarrisoned](#attackgarrisoned)
* [AttackFrontal](#attackfrontal)
* [AttackWander](#attackwander)
* [AttackLeap](#attackleap)
* [AttackMedic](#attackmedic)
* [AttackCharge](#attackcharge)
* [AttackFollow](#attackfollow)
* [AttackLoyalty](#attackloyalty)
* [AttackOmni](#attackomni)
* [Transforms](#transforms)
* [Cargo](#cargo)
* [LoadWidgetAtGameStart](#loadwidgetatgamestart)
* [ChronoshiftPaletteEffect](#chronoshiftpaletteeffect)
* [BridgeHut](#bridgehut)
* [VoxelNormalsPalette](#voxelnormalspalette)
* [BaseBuilding](#basebuilding)
* [MadTank](#madtank)
* [SpawnMPUnits](#spawnmpunits)
* [InvulnerabilityUpgrade](#invulnerabilityupgrade)
* [CombatDebugOverlay](#combatdebugoverlay)
* [Buildable](#buildable)
* [ThrowsParticle](#throwsparticle)
* [CloakPaletteEffect](#cloakpaletteeffect)
* [Immobile](#immobile)
* [Mine](#mine)
* [MineImmune](#mineimmune)
* [RepairsBridges](#repairsbridges)
* [UpgradeActorsNear](#upgradeactorsnear)
* [Parachutable](#parachutable)
* [Invulnerable](#invulnerable)
* [DemoTruck](#demotruck)
* [Fake](#fake)
* [Guard](#guard)
* [Guardable](#guardable)
* [Harvester](#harvester)
* [Repairable](#repairable)
* [Crushable](#crushable)
* [LeavesHusk](#leaveshusk)
* [SpawnMapActors](#spawnmapactors)
* [RepairableNear](#repairablenear)
* [UpgradeManager](#upgrademanager)
* [SmokeTrailWhenDamaged](#smoketrailwhendamaged)
* [Reloads](#reloads)
* [AcceptsSupplies](#acceptssupplies)
* [PaletteFromCurrentTileset](#palettefromcurrenttileset)
* [TargetableBuilding](#targetablebuilding)
* [RenderJammerCircle](#renderjammercircle)
* [RadarColorFromTerrain](#radarcolorfromterrain)
* [ProductionQueueFromSelection](#productionqueuefromselection)
* [Capturable](#capturable)
* [ShroudPalette](#shroudpalette)
* [AttackMove](#attackmove)
* [WithRangeCircle](#withrangecircle)
* [AnnounceOnBuild](#announceonbuild)
* [KillsSelf](#killsself)
* [C4Demolition](#c4demolition)
* [TransformOnCapture](#transformoncapture)
* [CrateAction](#crateaction)
* [Chronoshiftable](#chronoshiftable)
* [ScaredyCat](#scaredycat)
* [Tooltip](#tooltip)
* [MPStartLocations](#mpstartlocations)
* [GivesBounty](#givesbounty)
* [Passenger](#passenger)
* [Minelayer](#minelayer)
* [SeedsResource](#seedsresource)
* [ActorLostNotification](#actorlostnotification)
* [ProductionBar](#productionbar)
* [GivesExperience](#givesexperience)
* [HideMapCrateAction](#hidemapcrateaction)
* [ExplodeCrateAction](#explodecrateaction)
* [LevelUpCrateAction](#levelupcrateaction)
* [RevealMapCrateAction](#revealmapcrateaction)
* [GiveCashCrateAction](#givecashcrateaction)
* [CaptureNotification](#capturenotification)
* [ExternalCaptures](#externalcaptures)
* [NukePaletteEffect](#nukepaletteeffect)
* [Explodes](#explodes)
* [SupplyTruck](#supplytruck)
* [Bridge](#bridge)
* [ExternalCapturable](#externalcapturable)
* [StartGameNotification](#startgamenotification)
* [RenderShroudCircle](#rendershroudcircle)
* [PlayerPaletteFromCurrentTileset](#playerpalettefromcurrenttileset)
* [AnnounceOnKill](#announceonkill)
* [Huntable](#huntable)
* [HackyAI](#hackyai)
* [Aircraft](#aircraft)
* [FlyAwayOnIdle](#flyawayonidle)
* [Helicopter](#helicopter)
* [AttackPlane](#attackplane)
* [TargetableAircraft](#targetableaircraft)
* [AttackHeli](#attackheli)
* [FallsToEarth](#fallstoearth)
* [ReturnOnIdle](#returnonidle)
* [Plane](#plane)
* [RepairableBuilding](#repairablebuilding)
* [BuildingInfluence](#buildinginfluence)
* [Bib](#bib)
* [LineBuild](#linebuild)
* [LaysTerrain](#laysterrain)
* [CustomBuildTimeValue](#custombuildtimevalue)
* [LineBuildNode](#linebuildnode)
* [GivesBuildableArea](#givesbuildablearea)
* [Building](#building)
* [CustomSellValue](#customsellvalue)
* [ShakeOnDeath](#shakeondeath)
* [SoundOnDamageTransition](#soundondamagetransition)
* [BaseProvider](#baseprovider)
* [DuplicateUnitCrateAction](#duplicateunitcrateaction)
* [GrantUpgradeCrateAction](#grantupgradecrateaction)
* [GiveMcvCrateAction](#givemcvcrateaction)
* [GiveUnitCrateAction](#giveunitcrateaction)
* [HealUnitsCrateAction](#healunitscrateaction)
* [SupportPowerCrateAction](#supportpowercrateaction)
* [GpsDot](#gpsdot)
* [InfiltrateForPowerOutage](#infiltrateforpoweroutage)
* [InfiltrateForExploration](#infiltrateforexploration)
* [InfiltrateForSupportPower](#infiltrateforsupportpower)
* [InfiltrateForCash](#infiltrateforcash)
* [Infiltrates](#infiltrates)
* [PathFinder](#pathfinder)
* [Mobile](#mobile)
* [Power](#power)
* [ScalePowerWithHealth](#scalepowerwithhealth)
* [RequiresPower](#requirespower)
* [AffectedByPowerOutage](#affectedbypoweroutage)
* [PowerManager](#powermanager)
* [CanPowerDown](#canpowerdown)
* [RenderBuildingTurreted](#renderbuildingturreted)
* [RenderBuildingCharge](#renderbuildingcharge)
* [WithBuildingPlacedAnimation](#withbuildingplacedanimation)
* [WithActiveAnimation](#withactiveanimation)
* [RenderDisguise](#renderdisguise)
* [WithRotor](#withrotor)
* [WithTurret](#withturret)
* [WithShadow](#withshadow)
* [RenderUnit](#renderunit)
* [WithRepairOverlay](#withrepairoverlay)
* [WithCrateBody](#withcratebody)
* [RenderBuildingWarFactory](#renderbuildingwarfactory)
* [WithBarrel](#withbarrel)
* [RenderUnitReload](#renderunitreload)
* [RenderNameTag](#rendernametag)
* [RenderSimple](#rendersimple)
* [RenderEditorOnly](#rendereditoronly)
* [WithHarvestAnimation](#withharvestanimation)
* [RenderBuilding](#renderbuilding)
* [RenderInfantry](#renderinfantry)
* [RenderBuildingWall](#renderbuildingwall)
* [RenderFlare](#renderflare)
* [WithBuildingExplosion](#withbuildingexplosion)
* [RenderLandingCraft](#renderlandingcraft)
* [RenderVoxels](#rendervoxels)
* [WithResources](#withresources)
* [WithVoxelBody](#withvoxelbody)
* [WithDeathAnimation](#withdeathanimation)
* [RenderHarvester](#renderharvester)
* [WithMakeAnimation](#withmakeanimation)
* [WithVoxelBarrel](#withvoxelbarrel)
* [WithIdleOverlay](#withidleoverlay)
* [RenderBuildingSilo](#renderbuildingsilo)
* [WithSmoke](#withsmoke)
* [WithRepairAnimation](#withrepairanimation)
* [WithVoxelTurret](#withvoxelturret)
* [WithMuzzleFlash](#withmuzzleflash)
* [RenderSprites](#rendersprites)
* [WithDeliveryAnimation](#withdeliveryanimation)
* [RenderGunboat](#rendergunboat)
* [ScriptTriggers](#scripttriggers)
* [LuaScript](#luascript)
* [RevealsShroud](#revealsshroud)
* [Selectable](#selectable)
* [Health](#health)
* [EditorTilesetFilter](#editortilesetfilter)
* [Armor](#armor)
* [Shroud](#shroud)
* [ActorMap](#actormap)
* [ResourceType](#resourcetype)
* [ScreenShaker](#screenshaker)
* [ScreenMap](#screenmap)
* [Country](#country)
* [DrawLineToTarget](#drawlinetotarget)
* [RejectsOrders](#rejectsorders)
* [DeveloperMode](#developermode)
* [FrozenActorLayer](#frozenactorlayer)
* [PlayerResources](#playerresources)
* [PlayerColorPalette](#playercolorpalette)
* [FixedColorPalette](#fixedcolorpalette)
* [PlayerHighlightPalette](#playerhighlightpalette)
* [DebugPauseState](#debugpausestate)
* [EditorAppearance](#editorappearance)
* [CreatesShroud](#createsshroud)
* [BodyOrientation](#bodyorientation)
* [ValidateOrder](#validateorder)
* [SelectionDecorations](#selectiondecorations)

### DeadBuildingState
Requires traits: `Health`, `RenderSimple`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>LingerTime</td><td>20</td><td>Integer</td><td></td></tr>
</table>

### PoisonedByTiberium
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Weapon</td><td>Tiberium</td><td>String</td><td></td></tr>
<tr><td>Resources</td><td>Tiberium, BlueTiberium</td><td>Multiple String</td><td></td></tr>
</table>

### TiberiumRefinery
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>DockOffset</td><td>1,2</td><td>2D Cell Vector</td><td></td></tr>
<tr><td>ShowTicks</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>TickLifetime</td><td>30</td><td>Integer</td><td></td></tr>
<tr><td>TickVelocity</td><td>2</td><td>Integer</td><td></td></tr>
<tr><td>TickRate</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>DockAngle</td><td>64</td><td>Integer</td><td></td></tr>
</table>

### SpawnViceroid
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ViceroidActor</td><td>vice</td><td>String</td><td></td></tr>
<tr><td>Probability</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>Owner</td><td>Creeps</td><td>String</td><td></td></tr>
<tr><td>DeathType</td><td>6</td><td>String</td><td></td></tr>
</table>

### ProductionAirdrop
Deliver the unit in production via skylift.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ReadyAudio</td><td>Reinforce</td><td>String</td><td></td></tr>
<tr><td>ActorType</td><td>c17</td><td>String</td><td>Cargo aircraft used. </td></tr>
<tr><td>Produces</td><td></td><td>Multiple String</td><td>e.g. Infantry, Vehicles, Aircraft, Buildings </td></tr>
</table>

### WithRoof
Provides an overlay for the Tiberian Dawn hover craft.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>roof</td><td>String</td><td></td></tr>
</table>

### WithCargo
Renders the cargo loaded into the unit.


Requires trait: `Cargo`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>LocalOffset</td><td></td><td>Multiple 3D World Vector</td><td>Cargo position relative to turret or body. (forward, right, up) triples </td></tr>
<tr><td>DisplayTypes</td><td></td><td>Multiple String</td><td>Passenger CargoType to display. </td></tr>
</table>

### WithFire
Renders a flame sprite on top of the actor.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>StartSequence</td><td>fire-start</td><td>String</td><td></td></tr>
<tr><td>LoopSequence</td><td>fire-loop</td><td>String</td><td></td></tr>
</table>

### IonCannonPower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CameraActor</td><td></td><td>String</td><td>Actor to spawn when the attack starts </td></tr>
<tr><td>CameraRemoveDelay</td><td>25</td><td>Integer</td><td>Amount of time to keep the camera alive </td></tr>
<tr><td>Effect</td><td>ionsfx</td><td>String</td><td>Effect sequence to display </td></tr>
<tr><td>EffectPalette</td><td>effect</td><td>String</td><td></td></tr>
<tr><td>Weapon</td><td>IonCannon</td><td>String</td><td>Which weapon to fire </td></tr>
<tr><td>WeaponDelay</td><td>7</td><td>Integer</td><td>Apply the weapon impact this many ticks into the effect </td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>IonCannonPowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### PlayMusicOnMapLoad
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Music</td><td></td><td>String</td><td></td></tr>
<tr><td>Loop</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### ResourceClaimLayer
Allows harvesters to coordinate their operations. Attach this to the world actor.

### RadarPings
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FromRadius</td><td>200</td><td>Integer</td><td></td></tr>
<tr><td>ToRadius</td><td>15</td><td>Integer</td><td></td></tr>
<tr><td>ShrinkSpeed</td><td>4</td><td>Integer</td><td></td></tr>
<tr><td>RotationSpeed</td><td>0.12</td><td>Real Number</td><td></td></tr>
</table>

### SmudgeLayer
Attach this to the world actor.
Order of the layers defines the Z sorting.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Type</td><td>Scorch</td><td>String</td><td></td></tr>
<tr><td>Sequence</td><td>scorch</td><td>String</td><td>Sprite sequence name </td></tr>
<tr><td>SmokePercentage</td><td>25</td><td>Integer</td><td></td></tr>
<tr><td>SmokeType</td><td>smoke_m</td><td>String</td><td>Sprite sequence name </td></tr>
<tr><td>Palette</td><td>terrain</td><td>String</td><td></td></tr>
</table>

### RallyPoint
Used to waypoint units after production or repair is finished.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RallyPoint</td><td>1,3</td><td>2D Cell Vector</td><td></td></tr>
<tr><td>IndicatorPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
</table>

### PaletteFromFile
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>internal palette name </td></tr>
<tr><td>Tileset</td><td></td><td>String</td><td>If defined, load the palette only for this tileset. </td></tr>
<tr><td>Filename</td><td></td><td>String</td><td>filename to load </td></tr>
<tr><td>ShadowIndex</td><td></td><td>Multiple Integer</td><td>Map listed indices to shadow. Ignores previous color. </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### ChatCommands
Enables commands triggered by typing them into the chatbox. Attach this to the world actor.

### PlayerCommands
Allows the player to pause or surrender the game via the chatbox. Attach this to the world actor.

### DevCommands
Enables developer cheats via the chatbox. Attach this to the world actor.

### HelpCommand
Shows a list of available commands in the chatbox. Attach this to the world actor.

### Contrail
Draw a colored contrail behind this actor when they move.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>TrailLength</td><td>25</td><td>Integer</td><td>Measured in pixels. </td></tr>
<tr><td>Color</td><td>255,255,255,255</td><td>Color</td><td>RGB color of the contrail. </td></tr>
<tr><td>UsePlayerColor</td><td>True</td><td>Boolean</td><td>Use player remap color instead of a custom color? </td></tr>
</table>

### JamsMissiles
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>AlliedMissiles</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>Chance</td><td>100</td><td>Integer</td><td></td></tr>
</table>

### ProvidesRadar
This actor enables the radar minimap.

### JamsRadar
When an actor with this trait is in range of an actor with ProvidesRadar, it will temporarily disable the radar minimap for the enemy player.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>0</td><td>Integer</td><td>Range for jamming. </td></tr>
</table>

### ThrowsShrapnel
Throws particles when the actor is destroyed that do damage on impact.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Weapons</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>Pieces</td><td>3, 10</td><td>Multiple Integer</td><td></td></tr>
<tr><td>Range</td><td>2048, 5120</td><td>Multiple 1D World Range</td><td></td></tr>
</table>

### FogPaletteFromR8
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>Internal palette name </td></tr>
<tr><td>Filename</td><td></td><td>String</td><td>Filename to load </td></tr>
<tr><td>Offset</td><td>0</td><td>Int64</td><td>Palette byte offset </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>InvertColor</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### ChooseBuildTabOnSelect
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>BuildPaletteWidgetName</td><td>INGAME_BUILD_PALETTE</td><td>String</td><td></td></tr>
</table>

### D2kResourceLayer
Used to render spice with round borders.

### PaletteFromScaledPalette
Create a palette by applying a scale and offset to the colors in another palette.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>Internal palette name </td></tr>
<tr><td>BasePalette</td><td></td><td>String</td><td>The name of the palette to base off. </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td>Allow palette modifiers to change the palette. </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Amount to scale the base palette colors by. </td></tr>
<tr><td>Offset</td><td>0</td><td>Integer</td><td>Amount to offset the base palette colors by. </td></tr>
</table>

### PaletteFromR8
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>Internal palette name </td></tr>
<tr><td>Filename</td><td></td><td>String</td><td>Filename to load </td></tr>
<tr><td>Offset</td><td>0</td><td>Int64</td><td>Palette byte offset </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>InvertColor</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### DamagedWithoutFoundation
Reduces health points over time when the actor is placed on unsafe terrain.


Requires trait: `Health`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Weapon</td><td>weathering</td><td>String</td><td></td></tr>
<tr><td>SafeTerrain</td><td>Concrete</td><td>Multiple String</td><td></td></tr>
<tr><td>DamageThreshold</td><td>50</td><td>Integer</td><td></td></tr>
</table>

### WithProductionOverlay
Renders an animation when the Production trait of the actor is activated.
Works both with per player ClassicProductionQueue and per building ProductionQueue, but needs any of these.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>production-overlay</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>IsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom palette is a player palette BaseName </td></tr>
</table>

### WithDeliveryOverlay
Rendered when ProductionAirdrop is in progress.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>active</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>IsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom palette is a player palette BaseName </td></tr>
</table>

### WithCrumbleOverlay
Rendered together with the "make" animation.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>crumble-overlay</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>IsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom palette is a player palette BaseName </td></tr>
</table>

### WithBuildingPlacedOverlay
Rendered when the actor constructed a building.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>crane-overlay</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>IsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom palette is a player palette BaseName </td></tr>
</table>

### WithDockingOverlay
Rendered when a harvester is docked.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>docking-overlay</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>IsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom palette is a player palette BaseName </td></tr>
</table>

### ProximityCaptor
Actor can capture ProximityCapturable actors.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Types</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### Reservable
Reserve landing places for aircraft.

### AutoHeal
Used together with AttackMedic: to make the healer do it's job automatically to nearby units.


Requires trait: `AttackBase`.

### CreateMPPlayers
Attach this to the world actor.

### DisguiseToolTip
Overrides the default ToolTip when this actor is disguised (aids in deceiving enemy players).


Requires trait: `Disguise`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>Name</td><td></td><td>String</td><td></td></tr>
<tr><td>GenericName</td><td></td><td>String</td><td>An optional generic name (i.e. "Soldier" or "Structure")to be shown to chosen players. </td></tr>
<tr><td>GenericStancePrefix</td><td>True</td><td>Boolean</td><td>Prefix generic tooltip name with 'Enemy' or 'Allied'. </td></tr>
<tr><td>GenericVisibility</td><td>None</td><td>Stance</td><td>Player stances that the generic name should be shown to. </td></tr>
<tr><td>ShowOwnerRow</td><td>True</td><td>Boolean</td><td>Show the actor's owner and their faction flag </td></tr>
<tr><td>Icon</td><td>icon</td><td>String</td><td>Sequence of the actor that contains the cameo. </td></tr>
</table>

### Disguise

### IgnoresDisguise

### Turreted
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Turret</td><td>primary</td><td>String</td><td></td></tr>
<tr><td>ROT</td><td>255</td><td>Integer</td><td>Rate of Turning </td></tr>
<tr><td>InitialFacing</td><td>128</td><td>Integer</td><td></td></tr>
<tr><td>RealignDelay</td><td>40</td><td>Integer</td><td>Number of ticks before turret is realigned. (-1 turns off realignment) </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Muzzle position relative to turret or body. (forward, right, up) triples </td></tr>
</table>

### GainsStatUpgrades
This actor has properties that upgrade when a specific criteria is met.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FirepowerUpgrade</td><td>firepower</td><td>String</td><td></td></tr>
<tr><td>FirepowerModifier</td><td>110, 115, 120, 130</td><td>Multiple Integer</td><td></td></tr>
<tr><td>DamageUpgrade</td><td>damage</td><td>String</td><td></td></tr>
<tr><td>DamageModifier</td><td>91, 87, 83, 65</td><td>Multiple Integer</td><td></td></tr>
<tr><td>SpeedUpgrade</td><td>speed</td><td>String</td><td></td></tr>
<tr><td>SpeedModifier</td><td>110, 115, 120, 150</td><td>Multiple Integer</td><td></td></tr>
<tr><td>ReloadUpgrade</td><td>reload</td><td>String</td><td></td></tr>
<tr><td>ReloadModifier</td><td>95, 90, 85, 75</td><td>Multiple Integer</td><td></td></tr>
<tr><td>InaccuracyUpgrade</td><td>inaccuracy</td><td>String</td><td></td></tr>
<tr><td>InaccuracyModifier</td><td>90, 80, 70, 50</td><td>Multiple Integer</td><td></td></tr>
</table>

### RepairsUnits
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ValuePercentage</td><td>20</td><td>Integer</td><td></td></tr>
<tr><td>HpPerStep</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>Interval</td><td>24</td><td>Integer</td><td></td></tr>
</table>

### BridgeLayer
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Bridges</td><td>bridge1, bridge2</td><td>Multiple String</td><td></td></tr>
</table>

### Production
This unit has access to build queues.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Produces</td><td></td><td>Multiple String</td><td>e.g. Infantry, Vehicles, Aircraft, Buildings </td></tr>
</table>

### Exit
Where the unit should leave the building. Multiples are allowed if IDs are added: Exit@2, ...
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>SpawnOffset</td><td>0,0,0</td><td>3D World Vector</td><td>Offset at which that the exiting actor is spawned </td></tr>
<tr><td>ExitCell</td><td>0,0</td><td>2D Cell Vector</td><td>Cell offset where the exiting actor enters the ActorMap </td></tr>
<tr><td>Facing</td><td>-1</td><td>Integer</td><td></td></tr>
<tr><td>MoveIntoWorld</td><td>True</td><td>Boolean</td><td>AttackMove to a RallyPoint or stay where you are spawned. </td></tr>
</table>

### AutoTarget
The actor will automatically engage the enemy when it is in range.


Requires trait: `AttackBase`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>AllowMovement</td><td>True</td><td>Boolean</td><td>It will try to hunt down the enemy if it is not set to defend. </td></tr>
<tr><td>ScanRadius</td><td>-1</td><td>Integer</td><td>Set to a value >1 to override weapons maximum range for this. </td></tr>
<tr><td>InitialStance</td><td>AttackAnything</td><td>UnitStance</td><td>Possible values are HoldFire, ReturnFire, Defend and AttackAnything. </td></tr>
<tr><td>EnableStances</td><td>True</td><td>Boolean</td><td>Allow the player to change the unit stance. </td></tr>
<tr><td>MinimumScanTimeInterval</td><td>3</td><td>Integer</td><td>Ticks to wait until next AutoTarget: attempt. </td></tr>
<tr><td>MaximumScanTimeInterval</td><td>8</td><td>Integer</td><td>Ticks to wait until next AutoTarget: attempt. </td></tr>
<tr><td>TargetWhenIdle</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>TargetWhenDamaged</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### AutoTargetIgnore
Will not get automatically targeted by enemy (like walls)

### HarvesterHuskModifier
Requires trait: `Harvester`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FullHuskActor</td><td></td><td>String</td><td></td></tr>
<tr><td>FullnessThreshold</td><td>50</td><td>Integer</td><td></td></tr>
</table>

### TransformOnPassenger
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PassengerTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>OnEnter</td><td></td><td>String</td><td></td></tr>
<tr><td>OnExit</td><td></td><td>String</td><td></td></tr>
<tr><td>SkipMakeAnims</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>BecomeNeutral</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### CrateSpawner
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Minimum</td><td>1</td><td>Integer</td><td>Minimum number of crates </td></tr>
<tr><td>Maximum</td><td>255</td><td>Integer</td><td>Maximum number of crates </td></tr>
<tr><td>SpawnInterval</td><td>180</td><td>Integer</td><td>Average time (seconds) between crate spawn </td></tr>
<tr><td>ValidGround</td><td>Clear, Rough, Road, Ore, Beach</td><td>Multiple String</td><td>Which terrain types can we drop on? </td></tr>
<tr><td>ValidWater</td><td>Water</td><td>Multiple String</td><td>Which terrain types count as water? </td></tr>
<tr><td>WaterChance</td><td>0.2</td><td>Real Number</td><td>Chance of generating a water crate instead of a land crate </td></tr>
<tr><td>CrateActors</td><td>crate</td><td>Multiple String</td><td>Crate actors to drop </td></tr>
<tr><td>CrateActorShares</td><td>10</td><td>Multiple Integer</td><td>Chance of each crate actor spawning </td></tr>
<tr><td>DeliveryAircraft</td><td></td><td>String</td><td>If a DeliveryAircraft: is specified, then this actor will deliver crates </td></tr>
<tr><td>QuantizedFacings</td><td>32</td><td>Integer</td><td>Number of facings that the delivery aircraft may approach from. </td></tr>
<tr><td>Cordon</td><td>5120</td><td>1D World Range</td><td>Spawn and remove the plane this far outside the map. </td></tr>
</table>

### CashTrickler
Lets the actor generate cash in a set periodic time.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Period</td><td>50</td><td>Integer</td><td>Number of ticks to wait between giving money. </td></tr>
<tr><td>Amount</td><td>15</td><td>Integer</td><td>Amount of money to give each time. </td></tr>
<tr><td>ShowTicks</td><td>True</td><td>Boolean</td><td>Whether to show the cash tick indicators (+$15 rising from actor). </td></tr>
<tr><td>CaptureAmount</td><td>0</td><td>Integer</td><td>Amount of money awarded for capturing the actor. </td></tr>
</table>

### DisableUpgrade
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RequiresUpgrade</td><td>disable</td><td>String</td><td></td></tr>
</table>

### TakeCover
Make the unit go prone when under attack, in an attempt to reduce damage.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ProneTime</td><td>100</td><td>Integer</td><td>How long (in ticks) the actor remains prone. </td></tr>
<tr><td>SpeedModifier</td><td>50</td><td>Integer</td><td>Prone movement speed as a percentage of the normal speed. </td></tr>
<tr><td>ProneOffset</td><td>85,0,-171</td><td>3D World Vector</td><td></td></tr>
<tr><td>ProneSequencePrefix</td><td>prone-</td><td>String</td><td></td></tr>
<tr><td>Turret</td><td>primary</td><td>String</td><td></td></tr>
<tr><td>ROT</td><td>255</td><td>Integer</td><td>Rate of Turning </td></tr>
<tr><td>InitialFacing</td><td>128</td><td>Integer</td><td></td></tr>
<tr><td>RealignDelay</td><td>40</td><td>Integer</td><td>Number of ticks before turret is realigned. (-1 turns off realignment) </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Muzzle position relative to turret or body. (forward, right, up) triples </td></tr>
</table>

### DetectCloaked
Actor can reveal Cloak actors in a specified range.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CloakTypes</td><td>Cloak</td><td>Multiple String</td><td>Specific cloak classifications I can reveal. </td></tr>
<tr><td>Range</td><td>5</td><td>Integer</td><td>Measured in cells. </td></tr>
</table>

### PrimaryBuilding
Used together with ClassicProductionQueue.

### WaterPaletteRotation
Palette effect used for sprinkle "animations" on terrain tiles.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ExcludePalettes</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### TimedUpgradeBar
Visualizes the remaining time for an upgrade.


Requires trait: `UpgradeManager`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Upgrade</td><td></td><td>String</td><td>Upgrade that this bar corresponds to </td></tr>
<tr><td>Color</td><td>255,255,0,0</td><td>Color</td><td></td></tr>
</table>

### RenderRangeCircle
Draw a circle indicating my weapon's range.


Requires trait: `AttackBase`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RangeCircleType</td><td></td><td>String</td><td></td></tr>
<tr><td>FallbackRange</td><td>0</td><td>1D World Range</td><td>Range to draw if no armaments are available </td></tr>
</table>

### EngineerRepair

### EngineerRepairable

### SpawnActorPower
Spawns an actor that stays for a limited amount of time.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Actor</td><td></td><td>String</td><td>Actor to spawn. </td></tr>
<tr><td>LifeTime</td><td>250</td><td>Integer</td><td>Amount of time to keep the actor alive in ticks. </td></tr>
<tr><td>DeploySound</td><td></td><td>String</td><td></td></tr>
<tr><td>EffectSequence</td><td></td><td>String</td><td></td></tr>
<tr><td>EffectPalette</td><td></td><td>String</td><td></td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>SpawnActorPowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### ChronoshiftPower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>1</td><td>Integer</td><td>Cells </td></tr>
<tr><td>Duration</td><td>30</td><td>Integer</td><td>Seconds </td></tr>
<tr><td>KillCargo</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>ChronoshiftPowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### GpsWatcher
Required for GpsPower. Attach this to the player actor.

### GpsPower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RevealDelay</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>GpsPowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### SupportPowerChargeBar
Display the time remaining until the super weapon attached to the actor is ready to the player and his allies.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Color</td><td>255,255,0,255</td><td>Color</td><td></td></tr>
</table>

### SupportPowerManager
Attach this to the player actor.


Requires traits: `DeveloperMode`, `TechTree`.

### AirstrikePower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>UnitType</td><td>badr.bomber</td><td>String</td><td></td></tr>
<tr><td>SquadSize</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>SquadOffset</td><td>-1536,1536,0</td><td>3D World Vector</td><td></td></tr>
<tr><td>QuantizedFacings</td><td>32</td><td>Integer</td><td></td></tr>
<tr><td>Cordon</td><td>5120</td><td>1D World Range</td><td></td></tr>
<tr><td>CameraActor</td><td></td><td>String</td><td>Actor to spawn when the aircraft start attacking </td></tr>
<tr><td>CameraRemoveDelay</td><td>25</td><td>Integer</td><td>Amount of time to keep the camera alive after the aircraft have finished attacking </td></tr>
<tr><td>BeaconDistanceOffset</td><td>6144</td><td>1D World Range</td><td>Weapon range offset to apply during the beacon clock calculation </td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>AirstrikePowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### GrantUpgradePower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Upgrades</td><td></td><td>Multiple String</td><td>The upgrades to apply. </td></tr>
<tr><td>Duration</td><td>0</td><td>Integer</td><td>Duration of the upgrade (in ticks). Set to 0 for a permanent upgrade. </td></tr>
<tr><td>Range</td><td>1</td><td>Integer</td><td>Cells </td></tr>
<tr><td>GrantUpgradeSound</td><td>ironcur9.aud</td><td>String</td><td></td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>GrantUpgradePowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### NukePower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MissileWeapon</td><td></td><td>String</td><td></td></tr>
<tr><td>SpawnOffset</td><td>0,0,0</td><td>3D World Vector</td><td></td></tr>
<tr><td>FlightDelay</td><td>400</td><td>Integer</td><td>Travel time - split equally between ascent and descent </td></tr>
<tr><td>FlightVelocity</td><td>512</td><td>1D World Range</td><td>Visual ascent velocity in WRange / tick </td></tr>
<tr><td>SkipAscent</td><td>False</td><td>Boolean</td><td>Descend immediately on the target, with half the FlightDelay </td></tr>
<tr><td>BeaconRemoveAdvance</td><td>25</td><td>Integer</td><td>Amount of time before detonation to remove the beacon </td></tr>
<tr><td>CameraActor</td><td></td><td>String</td><td>Actor to spawn before detonation </td></tr>
<tr><td>CameraSpawnAdvance</td><td>25</td><td>Integer</td><td>Amount of time before detonation to spawn the camera </td></tr>
<tr><td>CameraRemoveDelay</td><td>25</td><td>Integer</td><td>Amount of time after detonation to remove the camera </td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>NukePowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### ParatroopersPower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>UnitType</td><td>badr</td><td>String</td><td></td></tr>
<tr><td>SquadSize</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>SquadOffset</td><td>-1536,1536,0</td><td>3D World Vector</td><td></td></tr>
<tr><td>QuantizedFacings</td><td>32</td><td>Integer</td><td>Number of facings that the delivery aircraft may approach from. </td></tr>
<tr><td>Cordon</td><td>5120</td><td>1D World Range</td><td>Spawn and remove the plane this far outside the map. </td></tr>
<tr><td>DropItems</td><td></td><td>Multiple String</td><td>Troops to be delivered.  They will be distributed between the planes if SquadSize > 1. </td></tr>
<tr><td>AllowImpassableCells</td><td>False</td><td>Boolean</td><td>Risks stuck units when they don't have the Paratrooper trait. </td></tr>
<tr><td>CameraActor</td><td></td><td>String</td><td>Actor to spawn when the paradrop starts. </td></tr>
<tr><td>CameraRemoveDelay</td><td>85</td><td>Integer</td><td>Amount of time (in ticks) to keep the camera alive while the passengers drop. </td></tr>
<tr><td>BeaconDistanceOffset</td><td>4096</td><td>1D World Range</td><td>Weapon range offset to apply during the beacon clock calculation. </td></tr>
<tr><td>ChargeTime</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Icon</td><td></td><td>String</td><td></td></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>LongDesc</td><td></td><td>String</td><td></td></tr>
<tr><td>AllowMultiple</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>OneShot</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>BeginChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>EndChargeSound</td><td></td><td>String</td><td></td></tr>
<tr><td>SelectTargetSound</td><td></td><td>String</td><td></td></tr>
<tr><td>InsufficientPowerSound</td><td></td><td>String</td><td></td></tr>
<tr><td>LaunchSound</td><td></td><td>String</td><td></td></tr>
<tr><td>IncomingSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisplayTimer</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisplayBeacon</td><td>False</td><td>Boolean</td><td>Beacons are only supported on the Airstrike and Nuke powers </td></tr>
<tr><td>BeaconPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
<tr><td>BeaconPoster</td><td></td><td>String</td><td></td></tr>
<tr><td>BeaconPosterPalette</td><td>chrome</td><td>String</td><td></td></tr>
<tr><td>DisplayRadarPing</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>125</td><td>Integer</td><td></td></tr>
<tr><td>OrderName</td><td>ParatroopersPowerInfoOrder</td><td>String</td><td></td></tr>
</table>

### Cloneable
Actors with the "ClonesProducedUnits" trait will produce a free duplicate of me.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Types</td><td></td><td>Multiple String</td><td>This unit's cloneable type is: </td></tr>
</table>

### FreeActor
Player recives a unit for free once the building is placed. This also works for structures.
If you want more than one unit to appear copy this section and assign IDs like FreeActor@2, ...
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Actor</td><td></td><td>String</td><td>Name of actor (use HARV if this trait is for refineries) </td></tr>
<tr><td>InitialActivity</td><td></td><td>String</td><td>What the unit should start doing. Warning: If this is not a harvester it will break if you use FindResources. </td></tr>
<tr><td>SpawnOffset</td><td>0,0</td><td>2D Cell Vector</td><td>Offset relative to structure-center in 2D (e.g. 1, 2) </td></tr>
<tr><td>Facing</td><td>0</td><td>Integer</td><td>Which direction the unit should face. </td></tr>
</table>

### TargetableSubmarine


Requires trait: `Cloak`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CloakedTargetTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>TargetTypes</td><td></td><td>Multiple String</td><td>Target type. Used for filtering (in)valid targets. </td></tr>
<tr><td>RequiresForceFire</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### AttackBomber
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Bombs</td><td>primary</td><td>String</td><td>Armament name </td></tr>
<tr><td>Guns</td><td>secondary</td><td>String</td><td>Armament name </td></tr>
<tr><td>FacingTolerance</td><td>2</td><td>Integer</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### RenderDetectionCircle

### PortableChrono
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ChargeTime</td><td>20</td><td>Integer</td><td>Cooldown in seconds until the unit can teleport. </td></tr>
<tr><td>HasDistanceLimit</td><td>True</td><td>Boolean</td><td>Can the unit teleport only a certain distance? </td></tr>
<tr><td>MaxDistance</td><td>12</td><td>Integer</td><td>The maximum distance in cells this unit can teleport (only used if HasDistanceLimit = true). </td></tr>
<tr><td>ChronoshiftSound</td><td>chrotnk1.aud</td><td>String</td><td>Sound to play when teleporting. </td></tr>
</table>

### GainsExperience
This actor's experience increases when it has killed a GivesExperience actor.


Requires trait: `Valued`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Upgrades</td><td></td><td>Dictionary<Integer,Multiple String></td><td>Upgrades to grant at each level Key is the XP requirements for each level as a percentage of our own value. Value is a list of the upgrade types to grant </td></tr>
<tr><td>ChevronPalette</td><td>effect</td><td>String</td><td>Palette for the chevron glyph rendered in the selection box. </td></tr>
<tr><td>LevelUpPalette</td><td>effect</td><td>String</td><td>Palette for the level up sprite. </td></tr>
</table>

### EjectOnDeath
Eject a ground soldier or a paratrooper while in the air.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PilotActor</td><td>E1</td><td>String</td><td></td></tr>
<tr><td>SuccessRate</td><td>50</td><td>Integer</td><td></td></tr>
<tr><td>ChuteSound</td><td>chute1.aud</td><td>String</td><td></td></tr>
<tr><td>EjectInAir</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>EjectOnGround</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>AllowUnsuitableCell</td><td>False</td><td>Boolean</td><td>Risks stuck units when they don't have the Paratrooper trait. </td></tr>
</table>

### StrategicPoint

### StrategicVictoryConditions
Requires trait: `MissionObjectives`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>TicksToHold</td><td>7500</td><td>Integer</td><td>Amount of time (in game ticks) that the player has to hold all the strategic points. </td></tr>
<tr><td>ResetOnHoldLost</td><td>True</td><td>Boolean</td><td>Should the timer reset when the player loses hold of a strategic point. </td></tr>
<tr><td>RatioRequired</td><td>0.5</td><td>Real Number</td><td>Percentage of strategic points the player has to hold to win. </td></tr>
<tr><td>NotificationDelay</td><td>1500</td><td>Integer</td><td>Delay for the end game notification in milliseconds. </td></tr>
</table>

### ShroudRenderer
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>shroud</td><td>String</td><td></td></tr>
<tr><td>ShroudVariants</td><td>shroud</td><td>Multiple String</td><td></td></tr>
<tr><td>FogVariants</td><td>fog</td><td>Multiple String</td><td></td></tr>
<tr><td>ShroudPalette</td><td>shroud</td><td>String</td><td></td></tr>
<tr><td>FogPalette</td><td>fog</td><td>String</td><td></td></tr>
<tr><td>Index</td><td>12, 9, 8, 3, 1, 6, 4, 2, 13, 11, 7, 14</td><td>Multiple Integer</td><td>Bitfield of shroud directions for each frame. Lower four bits are corners clockwise from TL; upper four are edges clockwise from top </td></tr>
<tr><td>UseExtendedIndex</td><td>False</td><td>Boolean</td><td>Use the upper four bits when calculating frame </td></tr>
<tr><td>OverrideFullShroud</td><td></td><td>String</td><td>Override for source art that doesn't define a fully shrouded tile </td></tr>
<tr><td>OverrideShroudIndex</td><td>15</td><td>Integer</td><td></td></tr>
<tr><td>OverrideFullFog</td><td></td><td>String</td><td>Override for source art that doesn't define a fully fogged tile </td></tr>
<tr><td>OverrideFogIndex</td><td>15</td><td>Integer</td><td></td></tr>
<tr><td>ShroudBlend</td><td>Alpha</td><td>BlendMode</td><td></td></tr>
</table>

### Captures
This actor can capture other actors which have the Capturable: trait.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CaptureTypes</td><td>building</td><td>Multiple String</td><td>Types of actors that it can capture, as long as the type also exists in the Capturable Type: trait. </td></tr>
<tr><td>Sabotage</td><td>True</td><td>Boolean</td><td>Unit will do damage to the actor instead of capturing it. Unit is destroyed when sabotaging. </td></tr>
<tr><td>SabotageHPRemoval</td><td>0.5</td><td>Real Number</td><td>Only used if Sabotage=true. Sabotage damage expressed as a percentage of enemy health removed. </td></tr>
</table>

### MenuPaletteEffect
Fades the world from/to black at the start/end of the game, and can (optionally) desaturate the world
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FadeLength</td><td>10</td><td>Integer</td><td>Time (in ticks) to fade between states </td></tr>
<tr><td>Effect</td><td>None</td><td>EffectType</td><td>Effect style to fade to during gameplay. Accepts values of None or Desaturated. </td></tr>
<tr><td>MenuEffect</td><td>None</td><td>EffectType</td><td>Effect style to fade to when opening the in-game menu. Accepts values of None, Black or Desaturated. </td></tr>
</table>

### ConquestVictoryConditions
Requires trait: `MissionObjectives`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>NotificationDelay</td><td>1500</td><td>Integer</td><td>Delay for the end game notification in milliseconds. </td></tr>
</table>

### MustBeDestroyed
Tag trait for things that must be destroyed for a short game to end.

### GlobalUpgradable
Requires trait: `UpgradeManager`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Upgrades</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### ResourceLayer
Attach this to the world actor.
Order of the layers defines the Z sorting.


Requires trait: `ResourceType`.

### PathfinderDebugOverlay
Required for the A* PathDebug from DeveloperMode. Attach this to the world actor.

### BuildableTerrainLayer
Attach this to the world actor. Required for LaysTerrain to work.

### DomainIndex
Identify untraversable regions of the map for faster pathfinding, especially with AI.
This trait is required. Every mod needs it attached to the world actor.

### Armament
Allows you to attach weapons to the unit (use @IdentifierSuffix for > 1)


Requires trait: `AttackBase`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td>primary</td><td>String</td><td></td></tr>
<tr><td>Weapon</td><td></td><td>String</td><td>Has to be defined here and in weapons.yaml. </td></tr>
<tr><td>Turret</td><td>primary</td><td>String</td><td></td></tr>
<tr><td>FireDelay</td><td>0</td><td>Integer</td><td>Time (in frames) until the weapon can fire again. </td></tr>
<tr><td>LocalOffset</td><td></td><td>Multiple 3D World Vector</td><td>Muzzle position relative to turret or body. (forward, right, up) triples </td></tr>
<tr><td>LocalYaw</td><td></td><td>Multiple 1D World Angle</td><td>Muzzle yaw relative to turret or body. </td></tr>
<tr><td>Recoil</td><td>0</td><td>1D World Range</td><td>Move the turret backwards when firing. </td></tr>
<tr><td>RecoilRecovery</td><td>9</td><td>1D World Range</td><td>Recoil recovery per-frame </td></tr>
<tr><td>MuzzleSequence</td><td></td><td>String</td><td>Muzzle flash sequence to render </td></tr>
<tr><td>MuzzlePalette</td><td>effect</td><td>String</td><td>Palette to render Muzzle flash sequence in </td></tr>
<tr><td>MuzzleSplitFacings</td><td>0</td><td>Integer</td><td>Use multiple muzzle images if non-zero </td></tr>
<tr><td>RequiresUpgrade</td><td></td><td>String</td><td>Enable only if this upgrade is enabled. </td></tr>
<tr><td>RestrictedByUpgrade</td><td></td><td>String</td><td>Disable if this upgrade is enabled. </td></tr>
</table>

### OreRefinery
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>DockOffset</td><td>1,2</td><td>2D Cell Vector</td><td></td></tr>
<tr><td>ShowTicks</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>TickLifetime</td><td>30</td><td>Integer</td><td></td></tr>
<tr><td>TickVelocity</td><td>2</td><td>Integer</td><td></td></tr>
<tr><td>TickRate</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>DockAngle</td><td>64</td><td>Integer</td><td></td></tr>
</table>

### ExternalCapturableBar
Visualize the remaining CaptureCompleteTime from ExternalCapturable: trait.


Requires trait: `ExternalCapturable`.

### Demolishable
Handle demolitions from C4 explosives.

### ClonesProducedUnits
Creates a free duplicate of produced units.


Requires traits: `Exit`, `Production`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CloneableTypes</td><td></td><td>Multiple String</td><td>Uses the "Cloneable" trait to determine whether or not we should clone a produced unit. </td></tr>
</table>

### Husk
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>AllowedTerrain</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### StoresResources
Used for silos.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PipCount</td><td>0</td><td>Integer</td><td>Number of little squares used to display how filled unit is. </td></tr>
<tr><td>PipColor</td><td>Yellow</td><td>PipType</td><td></td></tr>
<tr><td>Capacity</td><td>0</td><td>Integer</td><td></td></tr>
</table>

### SelfHealing
Attach this to actors which should be able to regenerate their health points.


Requires trait: `Health`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Step</td><td>5</td><td>Integer</td><td></td></tr>
<tr><td>Ticks</td><td>5</td><td>Integer</td><td></td></tr>
<tr><td>HealIfBelow</td><td>0.5</td><td>Real Number</td><td></td></tr>
<tr><td>DamageCooldown</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>RequiresUpgrade</td><td></td><td>String</td><td>Enable only if this upgrade is enabled. </td></tr>
</table>

### LimitedAmmo
Actor has a limited amount of ammo, after using it all the actor must reload in some way.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Ammo</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>PipCount</td><td>0</td><td>Integer</td><td>Defaults to value in Ammo. </td></tr>
<tr><td>PipType</td><td>Green</td><td>PipType</td><td></td></tr>
<tr><td>PipTypeEmpty</td><td>Transparent</td><td>PipType</td><td></td></tr>
<tr><td>ReloadTicks</td><td>50</td><td>Integer</td><td>Time to reload measured in ticks. </td></tr>
</table>

### BelowUnits

### TargetableUnit
Actor can be targeted.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>TargetTypes</td><td></td><td>Multiple String</td><td>Target type. Used for filtering (in)valid targets. </td></tr>
<tr><td>RequiresForceFire</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### MPStartUnits
Used by SpawnMPUnits. Attach these to the world actor. You can have multiple variants by adding @suffixes.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Class</td><td>none</td><td>String</td><td>Internal class ID. </td></tr>
<tr><td>ClassName</td><td>Unlabeled</td><td>String</td><td>Exposed via the UI to the player. </td></tr>
<tr><td>Races</td><td></td><td>Multiple String</td><td>Only available when selecting this faction. Leave empty for no restrictions. </td></tr>
<tr><td>BaseActor</td><td></td><td>String</td><td>The mobile construction vehicle. </td></tr>
<tr><td>SupportActors</td><td></td><td>Multiple String</td><td>A group of units ready to defend or scout. </td></tr>
<tr><td>InnerSupportRadius</td><td>2</td><td>Integer</td><td>Inner radius for spawning support actors </td></tr>
<tr><td>OuterSupportRadius</td><td>4</td><td>Integer</td><td>Outer radius for spawning support actors </td></tr>
</table>

### ProximityCapturable
Actor can be captured by units in a specified proximity.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Permanent</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Range</td><td>5</td><td>Integer</td><td></td></tr>
<tr><td>MustBeClear</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>CaptorTypes</td><td>Vehicle, Tank, Infantry</td><td>Multiple String</td><td></td></tr>
</table>

### BlocksBullets
This actor blocks bullets and missiles without 'High' property.

### ActorGroupProxy
Part of the unfinished group-movement system. Attach this to the player actor.

### HarvesterAttackNotifier
Plays an audio notification and shows a radar ping when a harvester is attacked.
Attach this to the player actor.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>NotifyInterval</td><td>30</td><td>Integer</td><td>Minimum duration (in seconds) between notification events. </td></tr>
<tr><td>RadarPingColor</td><td>255,255,0,0</td><td>Color</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>250</td><td>Integer</td><td>Length of time (in ticks) to display a location ping in the minimap. </td></tr>
<tr><td>Notification</td><td>HarvesterAttack</td><td>String</td><td>The audio notification type to play. </td></tr>
</table>

### GlobalUpgradeManager
Attach this to the player actor.


Requires trait: `TechTree`.

### ProductionQueue
Attach this to an actor (usually a building) to let it produce units or construct buildings.
If one builds another actor of this type, he will get a separate queue to create two actors
at the same time. Will only work together with the Production: trait.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Type</td><td></td><td>String</td><td>What kind of production will be added (e.g. Building, Infantry, Vehicle, ...) </td></tr>
<tr><td>Group</td><td></td><td>String</td><td>Group queues from separate buildings together into the same tab. </td></tr>
<tr><td>RequireOwner</td><td>True</td><td>Boolean</td><td>Filter buildable items based on their Owner. </td></tr>
<tr><td>Race</td><td></td><td>Multiple String</td><td>Only enable this queue for certain factions </td></tr>
<tr><td>Sticky</td><td>True</td><td>Boolean</td><td>Should the prerequisite remain enabled if the owner changes? </td></tr>
<tr><td>BuildSpeed</td><td>0.4</td><td>Real Number</td><td>This value is used to translate the unit cost into build time. </td></tr>
<tr><td>LowPowerSlowdown</td><td>3</td><td>Integer</td><td>The build time is multiplied with this value on low power. </td></tr>
<tr><td>ReadyAudio</td><td>UnitReady</td><td>String</td><td>Notification played when production is complete. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>BlockedAudio</td><td>NoBuild</td><td>String</td><td>Notification played when you can't train another unit when the build limit exceeded or the exit is jammed. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>QueuedAudio</td><td>Training</td><td>String</td><td>Notification played when user clicks on the build palette icon. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>OnHoldAudio</td><td>OnHold</td><td>String</td><td>Notification played when player right-clicks on the build palette icon. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>CancelledAudio</td><td>Cancelled</td><td>String</td><td>Notification played when player right-clicks on a build palette icon that is already on hold. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
</table>

### TechTree
Manages build limits and pre-requisites.
 Attach this to the player actor.

### AllyRepair
Attach this to the player actor to allow building repair by team mates.

### PlaceBuilding
Allows to execute build orders.
 Attach this to the player actor.

### BaseAttackNotifier
Plays an audio notification and shows a radar ping when a building is attacked.
Attach this to the player actor.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>NotifyInterval</td><td>30</td><td>Integer</td><td>Minimum duration (in seconds) between notification events. </td></tr>
<tr><td>RadarPingColor</td><td>255,255,0,0</td><td>Color</td><td></td></tr>
<tr><td>RadarPingDuration</td><td>250</td><td>Integer</td><td>Length of time (in ticks) to display a location ping in the minimap. </td></tr>
<tr><td>Notification</td><td>BaseAttack</td><td>String</td><td>The audio notification type to play. </td></tr>
</table>

### PlayerStatistics
Attach this to the player actor to collect observer stats.

### UpdatesPlayerStatistics
Attach this to a unit to update observer stats.

### ClassicProductionQueue
Attach this to the player actor (not a building!) to define a new shared build queue.
Will only work together with the Production: trait on the actor that actually does the production.
You will also want to add PrimaryBuildings: to let the user choose where new units should exit.


Requires traits: `PlayerResources`, `PowerManager`, `TechTree`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>SpeedUp</td><td>False</td><td>Boolean</td><td>If you build more actors of the same type, the same queue will get its build time lowered for every actor produced there. </td></tr>
<tr><td>BuildTimeSpeedReduction</td><td>100, 85, 75, 65, 60, 55, 50</td><td>Multiple Integer</td><td>Every time another production building of the same queue is contructed, the build times of all actors in the queue decreased by a percentage of the original time. </td></tr>
<tr><td>Type</td><td></td><td>String</td><td>What kind of production will be added (e.g. Building, Infantry, Vehicle, ...) </td></tr>
<tr><td>Group</td><td></td><td>String</td><td>Group queues from separate buildings together into the same tab. </td></tr>
<tr><td>RequireOwner</td><td>True</td><td>Boolean</td><td>Filter buildable items based on their Owner. </td></tr>
<tr><td>Race</td><td></td><td>Multiple String</td><td>Only enable this queue for certain factions </td></tr>
<tr><td>Sticky</td><td>True</td><td>Boolean</td><td>Should the prerequisite remain enabled if the owner changes? </td></tr>
<tr><td>BuildSpeed</td><td>0.4</td><td>Real Number</td><td>This value is used to translate the unit cost into build time. </td></tr>
<tr><td>LowPowerSlowdown</td><td>3</td><td>Integer</td><td>The build time is multiplied with this value on low power. </td></tr>
<tr><td>ReadyAudio</td><td>UnitReady</td><td>String</td><td>Notification played when production is complete. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>BlockedAudio</td><td>NoBuild</td><td>String</td><td>Notification played when you can't train another unit when the build limit exceeded or the exit is jammed. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>QueuedAudio</td><td>Training</td><td>String</td><td>Notification played when user clicks on the build palette icon. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>OnHoldAudio</td><td>OnHold</td><td>String</td><td>Notification played when player right-clicks on the build palette icon. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
<tr><td>CancelledAudio</td><td>Cancelled</td><td>String</td><td>Notification played when player right-clicks on a build palette icon that is already on hold. The filename of the audio is defined per faction in notifications.yaml. </td></tr>
</table>

### ProvidesCustomPrerequisite
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Prerequisite</td><td></td><td>String</td><td>The prerequisite type that this provides </td></tr>
<tr><td>RequiresPrerequisites</td><td></td><td>Multiple String</td><td>Only grant this prerequisite when you have these prerequisites </td></tr>
<tr><td>Race</td><td></td><td>Multiple String</td><td>Only grant this prerequisite for certain factions </td></tr>
<tr><td>ResetOnOwnerChange</td><td>False</td><td>Boolean</td><td>Should it recheck everything when it is captured? </td></tr>
</table>

### PlaceBeacon
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Duration</td><td>750</td><td>Integer</td><td></td></tr>
<tr><td>NotificationType</td><td>Sounds</td><td>String</td><td></td></tr>
<tr><td>Notification</td><td>Beacon</td><td>String</td><td></td></tr>
<tr><td>PalettePrefix</td><td>player</td><td>String</td><td></td></tr>
</table>

### ProvidesTechPrerequisite
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td></td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### MissionObjectives
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Cooperative</td><td>False</td><td>Boolean</td><td>Set this to true if multiple cooperative players have a distinct set of objectives that each of them has to complete to win the game. This is mainly useful for multiplayer coop missions. Do not use this for skirmish team games. </td></tr>
<tr><td>EarlyGameOver</td><td>False</td><td>Boolean</td><td>If set to true, this setting causes the game to end immediately once the first player (or team of cooperative players) fails or completes his objectives.  If set to false, players that fail their objectives will stick around and become observers. </td></tr>
<tr><td>GameOverDelay</td><td>1500</td><td>Integer</td><td>Delay between the game over condition being met, and the game actually ending, in milliseconds. </td></tr>
</table>

### ObjectivesPanel
Provides game mode progress information for players.
Goes on WorldActor - observers don't have a player it can live on.
Current options for PanelName are 'SKIRMISH_STATS' and 'MISSION_OBJECTIVES'.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PanelName</td><td></td><td>String</td><td></td></tr>
</table>

### Sellable
Actor can be sold
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RefundPercent</td><td>50</td><td>Integer</td><td></td></tr>
<tr><td>SellSounds</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### Valued
How much the unit is worth.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Cost</td><td>0</td><td>Integer</td><td>Used in production, but also for bounties so remember to set it > 0 even for NPCs. </td></tr>
</table>

### DisabledOverlay
Use together with CanPowerDown/RequiresPower on buildings or Husk for vehicles.

### UpgradeOverlay
Display a colored overlay when a timed upgrade is active.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RequiresUpgrade</td><td></td><td>String</td><td>Upgrade that is required before this overlay is rendered </td></tr>
<tr><td>Palette</td><td>invuln</td><td>String</td><td>Palette to use when rendering the overlay </td></tr>
</table>

### FrozenUnderFog
This actor will remain visible (but not updated visually) under fog, once discovered.


Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>StartsRevealed</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### HiddenUnderFog
The actor stays invisible under fog of war.

### AppearsOnRadar
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>UseLocation</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### PaletteFromRGBA
Creates a single color palette without any base palette file.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>internal palette name </td></tr>
<tr><td>Tileset</td><td></td><td>String</td><td>If defined, load the palette only for this tileset. </td></tr>
<tr><td>R</td><td>0</td><td>Integer</td><td>red color component </td></tr>
<tr><td>G</td><td>0</td><td>Integer</td><td>green color component </td></tr>
<tr><td>B</td><td>0</td><td>Integer</td><td>blue color component </td></tr>
<tr><td>A</td><td>255</td><td>Integer</td><td>alpha channel (transparency) </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### ParaDrop
This unit can spawn and eject other actors while flying.


Requires trait: `Cargo`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>DropRange</td><td>4096</td><td>1D World Range</td><td>Distance around the drop-point to unload troops. </td></tr>
<tr><td>ChuteSound</td><td>chute1.aud</td><td>String</td><td>Sound to play when dropping. </td></tr>
</table>

### Burns
This actor will play a fire animation over its body and take damage over time.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Anim</td><td>1</td><td>String</td><td></td></tr>
<tr><td>Damage</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>Interval</td><td>8</td><td>Integer</td><td></td></tr>
</table>

### Cloak
This unit can cloak and uncloak in specific situations.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>InitialDelay</td><td>10</td><td>Integer</td><td>Measured in game ticks. </td></tr>
<tr><td>CloakDelay</td><td>30</td><td>Integer</td><td>Measured in game ticks. </td></tr>
<tr><td>UncloakOnAttack</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>UncloakOnMove</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>UncloakOnUnload</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>RequiresUpgrade</td><td></td><td>String</td><td>Enable only if this upgrade is enabled. </td></tr>
<tr><td>CloakSound</td><td></td><td>String</td><td></td></tr>
<tr><td>UncloakSound</td><td></td><td>String</td><td></td></tr>
<tr><td>Palette</td><td>cloak</td><td>String</td><td></td></tr>
<tr><td>CloakTypes</td><td>Cloak</td><td>Multiple String</td><td></td></tr>
</table>

### LightPaletteRotator
Palette effect used for blinking "animations" on actors.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ExcludePalettes</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### EmitInfantryOnSell
Spawn new actors when sold.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ValuePercent</td><td>40</td><td>Real Number</td><td></td></tr>
<tr><td>MinHpPercent</td><td>30</td><td>Real Number</td><td></td></tr>
<tr><td>ActorTypes</td><td>e1</td><td>Multiple String</td><td>Be sure to use lowercase. Default value is "e1". </td></tr>
</table>

### Crate
Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Lifetime</td><td>0</td><td>Integer</td><td>Length of time (in seconds) until the crate gets removed automatically. A value of zero disables auto-removal. </td></tr>
<tr><td>TerrainTypes</td><td></td><td>Multiple String</td><td>Allowed to land on. </td></tr>
<tr><td>CrushClass</td><td>crate</td><td>String</td><td>Define actors that can collect crates by setting this into the Crushes field from the Mobile trait. </td></tr>
</table>

### DeathSounds
Sounds to play when killed.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>DeathSound</td><td>Die</td><td>String</td><td>Death notification voice. </td></tr>
<tr><td>VolumeMultiplier</td><td>1</td><td>Real Number</td><td>Multiply volume with this factor. </td></tr>
<tr><td>DeathTypes</td><td></td><td>Multiple String</td><td>DeathTypes that this should be used for. If empty, this will be used as the default sound. </td></tr>
</table>

### AttackTurreted
Actor has a visual turret used to attack.


Requires trait: `Turreted`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackPopupTurreted
Actor's turret rises from the ground before attacking.


Requires traits: `Building`, `RenderBuilding`, `Turreted`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CloseDelay</td><td>125</td><td>Integer</td><td>How many game ticks should pass before closing the actor's turret. </td></tr>
<tr><td>DefaultFacing</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>ClosedDamageMultiplier</td><td>50</td><td>Integer</td><td>The percentage of damage that is received while this actor is closed. </td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackGarrisoned
Cargo can fire their weapons out of fire ports.


Requires trait: `Cargo`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PortOffsets</td><td></td><td>Multiple 3D World Vector</td><td>Fire port offsets in local coordinates. </td></tr>
<tr><td>PortYaws</td><td></td><td>Multiple 1D World Angle</td><td>Fire port yaw angles. </td></tr>
<tr><td>PortCones</td><td></td><td>Multiple 1D World Angle</td><td>Fire port yaw cone angle. </td></tr>
<tr><td>MuzzlePalette</td><td>effect</td><td>String</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackFrontal
Unit got to face the target
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FacingTolerance</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackWander
Will AttackMove to a random location within MoveRadius when idle.
This conflicts with player orders and should only be added to animal creeps.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MoveRadius</td><td>4</td><td>Integer</td><td></td></tr>
</table>

### AttackLeap
Dogs use this attack model.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Speed</td><td>426</td><td>1D World Range</td><td>Leap speed (in units/tick). </td></tr>
<tr><td>Angle</td><td>56</td><td>1D World Angle</td><td></td></tr>
<tr><td>FacingTolerance</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackMedic
Give the unit a "heal-weapon" that attacks friendly targets if they are damaged.
It conflicts with any other weapon or Attack*: trait because it will hurt friendlies during the
heal process then. It also won't work with buildings (use RepairsUnits: for them)
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FacingTolerance</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackCharge
Charges up before being able to attack.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MaxCharges</td><td>1</td><td>Integer</td><td>How many charges this actor has to attack with, once charged. </td></tr>
<tr><td>ReloadTime</td><td>120</td><td>Integer</td><td>Reload time for all charges (in ticks). </td></tr>
<tr><td>InitialChargeDelay</td><td>22</td><td>Integer</td><td>Delay for initial charge attack (in ticks). </td></tr>
<tr><td>ChargeDelay</td><td>3</td><td>Integer</td><td>Delay between charge attacks (in ticks). </td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackFollow
Actor will follow units until in range to attack them.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackLoyalty
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FacingTolerance</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### AttackOmni
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### Transforms
Actor becomes a specified actor type when this trait is triggered.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>IntoActor</td><td></td><td>String</td><td></td></tr>
<tr><td>Offset</td><td>0,0</td><td>2D Cell Vector</td><td></td></tr>
<tr><td>Facing</td><td>96</td><td>Integer</td><td></td></tr>
<tr><td>TransformSounds</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>NoTransformSounds</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### Cargo
This actor can transport Passenger actors.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MaxWeight</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>PipCount</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Types</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>InitialUnits</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>EjectOnSell</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### LoadWidgetAtGameStart
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Widget</td><td></td><td>String</td><td></td></tr>
<tr><td>ClearRoot</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### ChronoshiftPaletteEffect
Apply palette full screen rotations during chronoshifts. Add this to the world actor.

### BridgeHut

### VoxelNormalsPalette
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td>normals</td><td>String</td><td></td></tr>
<tr><td>Type</td><td>TiberianSun</td><td>NormalType</td><td>Can be TiberianSun or RedAlert2 </td></tr>
</table>

### BaseBuilding
Tag trait for construction yard and MCVs. Used by the cycle bases hotkey to identify actors.

### MadTank
Requires traits: `Explodes`, `RenderUnit`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ThumpSequence</td><td>piston</td><td>String</td><td></td></tr>
<tr><td>ThumpInterval</td><td>8</td><td>Integer</td><td></td></tr>
<tr><td>ThumpDamageWeapon</td><td>MADTankThump</td><td>String</td><td></td></tr>
<tr><td>ThumpShakeIntensity</td><td>3</td><td>Integer</td><td></td></tr>
<tr><td>ThumpShakeMultiplier</td><td>1,0</td><td>2D Real Number</td><td></td></tr>
<tr><td>ThumpShakeTime</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>ChargeDelay</td><td>96</td><td>Integer</td><td></td></tr>
<tr><td>ChargeSound</td><td>madchrg2.aud</td><td>String</td><td></td></tr>
<tr><td>DetonationDelay</td><td>42</td><td>Integer</td><td></td></tr>
<tr><td>DetonationSound</td><td>madexplo.aud</td><td>String</td><td></td></tr>
<tr><td>DetonationWeapon</td><td>MADTankDetonate</td><td>String</td><td></td></tr>
<tr><td>DriverActor</td><td>e1</td><td>String</td><td></td></tr>
</table>

### SpawnMPUnits
Spawn base actor at the spawnpoint and support units in an annulus around the base actor. Both are defined at MPStartUnits. Attach this to the world actor.


Requires traits: `MPStartLocations`, `MPStartUnits`.

### InvulnerabilityUpgrade
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RequiresUpgrade</td><td>invulnerability</td><td>String</td><td></td></tr>
</table>

### CombatDebugOverlay

### Buildable
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>The prerequisite names that must be available before this can be built. This can be prefixed with ! to invert the prerequisite (disabling production if the prerequisite is available) and/or ~ to hide the actor from the production palette if the prerequisite is not available. Prerequisites are granted by actors with the Building trait (with a prerequisite string given by the lower case actor name) and by the ProvidesCustomPrerequisite trait. </td></tr>
<tr><td>Owner</td><td></td><td>Multiple String</td><td>Restrict production to a specific race(s). **Deprecated**: Use race-specific prerequisites instead. </td></tr>
<tr><td>Queue</td><td></td><td>Multiple String</td><td>Production queue(s) that can produce this. </td></tr>
<tr><td>BuildAtProductionType</td><td></td><td>String</td><td>Override the production structure type (from the Production Produces list) that this unit should be built at. </td></tr>
<tr><td>BuildLimit</td><td>0</td><td>Integer</td><td>Disable production when there are more than this many of this actor on the battlefield. Set to 0 to disable. </td></tr>
<tr><td>InitialActivity</td><td></td><td>String</td><td>What the unit should start doing. Warning: If this is not a harvester it will break if you use FindResources. </td></tr>
<tr><td>BuildPaletteOrder</td><td>9999</td><td>Integer</td><td></td></tr>
</table>

### ThrowsParticle
Requires trait: `RenderSimple`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Anim</td><td></td><td>String</td><td></td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Initial position relative to body </td></tr>
<tr><td>MinThrowRange</td><td>256</td><td>1D World Range</td><td>Minimum distance to throw the particle </td></tr>
<tr><td>MaxThrowRange</td><td>768</td><td>1D World Range</td><td>Maximum distance to throw the particle </td></tr>
<tr><td>MinThrowAngle</td><td>85</td><td>1D World Angle</td><td>Minimum angle to throw the particle </td></tr>
<tr><td>MaxThrowAngle</td><td>170</td><td>1D World Angle</td><td>Maximum angle to throw the particle </td></tr>
<tr><td>Velocity</td><td>75</td><td>Integer</td><td>Speed to throw the particle (horizontal WPos/tick) </td></tr>
<tr><td>ROT</td><td>15</td><td>Real Number</td><td>Maximum rotation rate </td></tr>
</table>

### CloakPaletteEffect

### Immobile
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>OccupiesSpace</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### Mine
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CrushClasses</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>AvoidFriendly</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>DetonateClasses</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### MineImmune
Tag trait for stuff that should not trigger mines.

### RepairsBridges

### UpgradeActorsNear
Applies an upgrade to actors within a specified range.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Upgrades</td><td></td><td>Multiple String</td><td>The upgrades to grant. </td></tr>
<tr><td>Range</td><td>3072</td><td>1D World Range</td><td>The range to search for actors to upgrade. </td></tr>
<tr><td>ValidStances</td><td>Ally</td><td>Stance</td><td>What diplomatic stances are affected. </td></tr>
<tr><td>AffectsParent</td><td>False</td><td>Boolean</td><td>Grant the upgrades apply to this actor. </td></tr>
<tr><td>EnableSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DisableSound</td><td></td><td>String</td><td></td></tr>
</table>

### Parachutable
Can be paradropped by a ParaDrop actor.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>KilledOnImpassableTerrain</td><td>True</td><td>Boolean</td><td>If we land on invalid terrain for my actor type should we be killed? </td></tr>
<tr><td>GroundImpactSound</td><td></td><td>String</td><td></td></tr>
<tr><td>GroundCorpseSequence</td><td>corpse</td><td>String</td><td></td></tr>
<tr><td>GroundCorpsePalette</td><td>effect</td><td>String</td><td></td></tr>
<tr><td>WaterImpactSound</td><td></td><td>String</td><td></td></tr>
<tr><td>WaterCorpseSequence</td><td>small_splash</td><td>String</td><td></td></tr>
<tr><td>WaterCorpsePalette</td><td>effect</td><td>String</td><td></td></tr>
<tr><td>ParachuteSequence</td><td></td><td>String</td><td>Requires the sub-sequences "open" and "idle". </td></tr>
<tr><td>ParachutePalette</td><td></td><td>String</td><td>Optional, otherwise defaults to the palette the actor is using. </td></tr>
<tr><td>ParachuteShadowPalette</td><td>shadow</td><td>String</td><td>Used to clone the actor with this palette and render it with a visual offset below. </td></tr>
<tr><td>ParachuteOffset</td><td>0,0,0</td><td>3D World Vector</td><td></td></tr>
<tr><td>FallRate</td><td>13</td><td>Integer</td><td></td></tr>
<tr><td>ShadowSequence</td><td></td><td>String</td><td>Alternative to ParachuteShadowPalette which disables it and allows to set a custom sprite sequence instead. </td></tr>
<tr><td>ShadowPalette</td><td></td><td>String</td><td>Optional, otherwise defaults to the palette the actor is using. </td></tr>
</table>

### Invulnerable
This unit cannot be damaged.

### DemoTruck
Requires trait: `Explodes`.

### Fake
Display a sprite tag "fake" when selected.

### Guard
The player can give this unit the order to follow and protect friendly units with the Guardable trait.

### Guardable
This unit can be guarded (followed and protected) by a Guard unit.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>2</td><td>Integer</td><td></td></tr>
</table>

### Harvester
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>DeliveryBuildings</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>Capacity</td><td>28</td><td>Integer</td><td>How much resources it can carry. </td></tr>
<tr><td>LoadTicksPerBale</td><td>4</td><td>Integer</td><td></td></tr>
<tr><td>UnloadTicksPerBale</td><td>4</td><td>Integer</td><td>How fast it can dump it's carryage. </td></tr>
<tr><td>PipCount</td><td>7</td><td>Integer</td><td>How many squares to show the fill level. </td></tr>
<tr><td>HarvestFacings</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>Resources</td><td></td><td>Multiple String</td><td>Which resources it can harvest. </td></tr>
<tr><td>FullyLoadedSpeed</td><td>85</td><td>Integer</td><td>Percentage of maximum speed when fully loaded. </td></tr>
<tr><td>SearchFromProcRadius</td><td>24</td><td>Integer</td><td>Initial search radius (in cells) from the refinery that created us. </td></tr>
<tr><td>SearchFromOrderRadius</td><td>12</td><td>Integer</td><td>Search radius (in cells) from the last harvest order location to find more resources. </td></tr>
</table>

### Repairable
This actor can be sent to a structure for repairs.


Requires trait: `Health`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RepairBuildings</td><td>fix</td><td>Multiple String</td><td></td></tr>
</table>

### Crushable
This actor is crushable.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CrushSound</td><td></td><td>String</td><td>Sound to play when being crushed. </td></tr>
<tr><td>CrushClasses</td><td>infantry</td><td>Multiple String</td><td>Which crush classes does this actor belong to. </td></tr>
<tr><td>WarnProbability</td><td>75</td><td>Integer</td><td>Probability of mobile actors noticing and evading a crush attempt. </td></tr>
<tr><td>CrushedByFriendlies</td><td>False</td><td>Boolean</td><td>Will friendly units just crush me instead of pathing around. </td></tr>
</table>

### LeavesHusk
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>HuskActor</td><td></td><td>String</td><td></td></tr>
</table>

### SpawnMapActors

### RepairableNear
Requires trait: `Health`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Buildings</td><td>spen, syrd</td><td>Multiple String</td><td></td></tr>
<tr><td>CloseEnough</td><td>4</td><td>Integer</td><td></td></tr>
</table>

### UpgradeManager

### SmokeTrailWhenDamaged
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Interval</td><td>3</td><td>Integer</td><td></td></tr>
<tr><td>Sprite</td><td>smokey</td><td>String</td><td></td></tr>
<tr><td>MinDamage</td><td>Heavy</td><td>DamageState</td><td></td></tr>
</table>

### Reloads
Unit will reload its limited ammo itself.


Requires trait: `LimitedAmmo`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Count</td><td>0</td><td>Integer</td><td>How much ammo is reloaded after a certain period. </td></tr>
<tr><td>Period</td><td>50</td><td>Integer</td><td>How long it takes to do so. </td></tr>
<tr><td>ResetOnFire</td><td>False</td><td>Boolean</td><td>Whether or not reload counter should be reset when ammo has been fired. </td></tr>
</table>

### AcceptsSupplies
Tag trait for SupplyTruck: actors.

### PaletteFromCurrentTileset
Loads the palette specified in the tileset definition
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>internal palette name </td></tr>
<tr><td>ShadowIndex</td><td></td><td>Multiple Integer</td><td>Map listed indices to shadow. Ignores previous color. </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### TargetableBuilding
Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>TargetTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>RequiresForceFire</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### RenderJammerCircle

### RadarColorFromTerrain
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Terrain</td><td></td><td>String</td><td></td></tr>
</table>

### ProductionQueueFromSelection
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ProductionTabsWidget</td><td></td><td>String</td><td></td></tr>
<tr><td>ProductionPaletteWidget</td><td></td><td>String</td><td></td></tr>
</table>

### Capturable
This actor can be captured by a unit with Captures: trait.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Type</td><td>building</td><td>String</td><td>Type listed under Types in Captures: trait of actors that can capture this). </td></tr>
<tr><td>AllowAllies</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>AllowNeutral</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>AllowEnemies</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>CaptureThreshold</td><td>0.5</td><td>Real Number</td><td>Health percentage the target must be at (or below) before it can be captured. </td></tr>
<tr><td>CancelActivity</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### ShroudPalette
Adds the hard-coded shroud palette to the game
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td>shroud</td><td>String</td><td>Internal palette name </td></tr>
<tr><td>Fog</td><td>False</td><td>Boolean</td><td>Palette type </td></tr>
</table>

### AttackMove

### WithRangeCircle
Renders an arbitrary circle when selected or placing a structure
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Type</td><td></td><td>String</td><td>Type of range circle. used to decide which circles to draw on other structures during building placement. </td></tr>
<tr><td>Color</td><td>128,255,255,255</td><td>Color</td><td>Color of the circle </td></tr>
<tr><td>Range</td><td>0</td><td>1D World Range</td><td>Range of the circle </td></tr>
</table>

### AnnounceOnBuild
Play the Build voice of this actor when trained.

### KillsSelf
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RequiresUpgrade</td><td></td><td>String</td><td>Enable only if this upgrade is enabled. </td></tr>
<tr><td>RemoveInstead</td><td>False</td><td>Boolean</td><td>Remove the actor from the world (and destroy it) instead of killing it. </td></tr>
</table>

### C4Demolition
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>C4Delay</td><td>45</td><td>Integer</td><td>Delay to demolish the target once the C4 is planted.Measured in game ticks. Default is 1.8 seconds. </td></tr>
<tr><td>Flashes</td><td>3</td><td>Integer</td><td>Number of times to flash the target </td></tr>
<tr><td>FlashesDelay</td><td>4</td><td>Integer</td><td>Delay before the flashing starts </td></tr>
<tr><td>FlashInterval</td><td>4</td><td>Integer</td><td>Interval between each flash </td></tr>
<tr><td>FlashDuration</td><td>3</td><td>Integer</td><td>Duration of each flash </td></tr>
<tr><td>Voice</td><td>Attack</td><td>String</td><td>Voice string when planting explosive charges. </td></tr>
</table>

### TransformOnCapture
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>IntoActor</td><td></td><td>String</td><td></td></tr>
<tr><td>ForceHealthPercentage</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>SkipMakeAnims</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### CrateAction
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### Chronoshiftable
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ExplodeInstead</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>ChronoshiftSound</td><td>chrono2.aud</td><td>String</td><td></td></tr>
</table>

### ScaredyCat
Makes the unit automatically run around when taking damage.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PanicLength</td><td>250</td><td>Integer</td><td>How long (in ticks) the actor should panic for. </td></tr>
<tr><td>PanicSpeedModifier</td><td>200</td><td>Integer</td><td>Panic movement speed as a precentage of the normal speed. </td></tr>
<tr><td>AttackPanicChance</td><td>20</td><td>Integer</td><td>Chance (out of 100) the unit has to enter panic mode when attacked. </td></tr>
</table>

### Tooltip
Shown in the build palette widget.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Description</td><td></td><td>String</td><td></td></tr>
<tr><td>Name</td><td></td><td>String</td><td></td></tr>
<tr><td>GenericName</td><td></td><td>String</td><td>An optional generic name (i.e. "Soldier" or "Structure")to be shown to chosen players. </td></tr>
<tr><td>GenericStancePrefix</td><td>True</td><td>Boolean</td><td>Prefix generic tooltip name with 'Enemy' or 'Allied'. </td></tr>
<tr><td>GenericVisibility</td><td>None</td><td>Stance</td><td>Player stances that the generic name should be shown to. </td></tr>
<tr><td>ShowOwnerRow</td><td>True</td><td>Boolean</td><td>Show the actor's owner and their faction flag </td></tr>
<tr><td>Icon</td><td>icon</td><td>String</td><td>Sequence of the actor that contains the cameo. </td></tr>
</table>

### MPStartLocations
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>InitialExploreRange</td><td>5120</td><td>1D World Range</td><td></td></tr>
</table>

### GivesBounty
You get money for playing this actor.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Percentage</td><td>10</td><td>Integer</td><td>Calculated by Cost or CustomSellValue so they have to be set to avoid crashes. </td></tr>
<tr><td>LevelMod</td><td>125</td><td>Integer</td><td>Higher ranked units give higher bounties. </td></tr>
<tr><td>Stances</td><td>Neutral, Enemy</td><td>Multiple Stance</td><td>Destroying creeps and enemies is rewarded. </td></tr>
</table>

### Passenger
This actor can enter Cargo actors.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CargoType</td><td></td><td>String</td><td></td></tr>
<tr><td>PipType</td><td>Green</td><td>PipType</td><td></td></tr>
<tr><td>Weight</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>AlternateTransportsMode</td><td>Force</td><td>AlternateTransportsMode</td><td>Use to set when to use alternate transports (Never, Force, Default, Always). Force - use force move modifier (Alt) to enable. Default - use force move modifier (Alt) to disable. </td></tr>
<tr><td>MaxAlternateTransportAttempts</td><td>1</td><td>Integer</td><td>Number of retries using alternate transports. </td></tr>
<tr><td>AlternateTransportScanRange</td><td>5632</td><td>1D World Range</td><td>Range from self for looking for an alternate transport (default: 5.5 cells). </td></tr>
</table>

### Minelayer
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Mine</td><td>minv</td><td>String</td><td></td></tr>
<tr><td>RearmBuildings</td><td>fix</td><td>Multiple String</td><td></td></tr>
<tr><td>RearmSound</td><td>minelay1.aud</td><td>String</td><td></td></tr>
<tr><td>MinefieldDepth</td><td>1.5</td><td>Real Number</td><td></td></tr>
</table>

### SeedsResource
Lets the actor spread resources around it in a circle.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Interval</td><td>75</td><td>Integer</td><td></td></tr>
<tr><td>ResourceType</td><td>Ore</td><td>String</td><td></td></tr>
<tr><td>MaxRange</td><td>100</td><td>Integer</td><td></td></tr>
</table>

### ActorLostNotification
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Notification</td><td>UnitLost</td><td>String</td><td></td></tr>
<tr><td>NotifyAll</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### ProductionBar
Visualizes the remaining build time of actor produced here.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ProductionType</td><td></td><td>String</td><td>Production queue type, for actors with multiple queues. </td></tr>
<tr><td>Color</td><td>255,135,206,235</td><td>Color</td><td></td></tr>
</table>

### GivesExperience
This actor gives experience to a GainsExperience actor when they are killed.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Experience</td><td>-1</td><td>Integer</td><td>If -1, use the value of the unit cost. </td></tr>
<tr><td>FriendlyFire</td><td>False</td><td>Boolean</td><td>Grant experience for team-kills. </td></tr>
</table>

### HideMapCrateAction
Hides the entire map in shroud.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### ExplodeCrateAction
Fires a weapon at the location when collected.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Weapon</td><td></td><td>String</td><td>The weapon to fire upon collection. </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### LevelUpCrateAction
Gives experience levels to the collector.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Levels</td><td>1</td><td>Integer</td><td>Number of experience levels to give. </td></tr>
<tr><td>Range</td><td>3</td><td>1D World Range</td><td>The range to search for extra collectors in. Extra collectors will also be granted the crate action. </td></tr>
<tr><td>MaxExtraCollectors</td><td>4</td><td>Integer</td><td>The maximum number of extra collectors to grant the crate action to. </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### RevealMapCrateAction
Reveals the entire map.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>IncludeAllies</td><td>False</td><td>Boolean</td><td>Should the map also be revealed for the allies of the collector's owner. </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### GiveCashCrateAction
Gives cash to the collector.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Amount</td><td>2000</td><td>Integer</td><td>Amount of cash to give. </td></tr>
<tr><td>UseCashTick</td><td>False</td><td>Boolean</td><td>Should the collected amount be displayed as a cash tick? </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### CaptureNotification
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Notification</td><td>BuildingCaptured</td><td>String</td><td></td></tr>
<tr><td>NewOwnerVoice</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### ExternalCaptures
This actor can capture other actors which have the ExternalCapturable: trait.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CaptureTypes</td><td>building</td><td>Multiple String</td><td>Types of actors that it can capture, as long as the type also exists in the ExternalCapturable Type: trait. </td></tr>
<tr><td>ConsumeActor</td><td>False</td><td>Boolean</td><td>Destroy the unit after capturing. </td></tr>
</table>

### NukePaletteEffect
Apply palette full screen rotations during atom bomb explosions. Add this to the world actor.

### Explodes
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Weapon</td><td>UnitExplode</td><td>String</td><td></td></tr>
<tr><td>EmptyWeapon</td><td>UnitExplode</td><td>String</td><td></td></tr>
<tr><td>Chance</td><td>100</td><td>Integer</td><td></td></tr>
<tr><td>DeathType</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### SupplyTruck
Donate money to building if it has the AcceptSupplies: trait.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Payload</td><td>500</td><td>Integer</td><td>The amount of cash the owner of the building recieves. </td></tr>
</table>

### Bridge
Requires trait: `Health`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Long</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>RepairPropagationDelay</td><td>20</td><td>Integer</td><td>Delay (in ticks) between repairing adjacent spans in long bridges </td></tr>
<tr><td>Template</td><td>0</td><td>UInt16</td><td></td></tr>
<tr><td>DamagedTemplate</td><td>0</td><td>UInt16</td><td></td></tr>
<tr><td>DestroyedTemplate</td><td>0</td><td>UInt16</td><td></td></tr>
<tr><td>DestroyedPlusNorthTemplate</td><td>0</td><td>UInt16</td><td></td></tr>
<tr><td>DestroyedPlusSouthTemplate</td><td>0</td><td>UInt16</td><td></td></tr>
<tr><td>DestroyedPlusBothTemplate</td><td>0</td><td>UInt16</td><td></td></tr>
<tr><td>ShorePieces</td><td>br1, br2</td><td>Multiple String</td><td></td></tr>
<tr><td>NorthOffset</td><td></td><td>Multiple Integer</td><td></td></tr>
<tr><td>SouthOffset</td><td></td><td>Multiple Integer</td><td></td></tr>
<tr><td>DemolishWeapon</td><td>Demolish</td><td>String</td><td>The name of the weapon to use when demolishing the bridge </td></tr>
</table>

### ExternalCapturable
This actor can be captured by a unit with ExternalCaptures: trait.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Type</td><td>building</td><td>String</td><td>Type of actor (the ExternalCaptures: trait defines what Types it can capture). </td></tr>
<tr><td>AllowAllies</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>AllowNeutral</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>AllowEnemies</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>CaptureCompleteTime</td><td>15</td><td>Integer</td><td>Seconds it takes to change the owner. You might want to add a ExternalCapturableBar: trait, too. </td></tr>
</table>

### StartGameNotification
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Notification</td><td>StartGame</td><td>String</td><td></td></tr>
</table>

### RenderShroudCircle

### PlayerPaletteFromCurrentTileset
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>internal palette name </td></tr>
<tr><td>ShadowIndex</td><td></td><td>Multiple Integer</td><td>Map listed indices to shadow. </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td>Apply palette rotatotors or not. </td></tr>
</table>

### AnnounceOnKill
Play the Kill voice of this actor when eliminating enemies.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Interval</td><td>5</td><td>Integer</td><td>Minimum duration (in seconds) between sound events. </td></tr>
</table>

### Huntable

### HackyAI
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td>Unnamed Bot</td><td>String</td><td>Ingame name this bot uses. </td></tr>
<tr><td>SquadSize</td><td>8</td><td>Integer</td><td>Minimum number of units AI must have before attacking. </td></tr>
<tr><td>BuildingQueues</td><td>Building</td><td>Multiple String</td><td>Production queues AI uses for buildings. </td></tr>
<tr><td>DefenseQueues</td><td>Defense</td><td>Multiple String</td><td>Production queues AI uses for defenses. </td></tr>
<tr><td>AssignRolesInterval</td><td>20</td><td>Integer</td><td>Delay (in ticks) between giving out orders to units. </td></tr>
<tr><td>RushInterval</td><td>600</td><td>Integer</td><td>Delay (in ticks) between attempting rush attacks. </td></tr>
<tr><td>AttackForceInterval</td><td>30</td><td>Integer</td><td>Delay (in ticks) between updating squads. </td></tr>
<tr><td>StructureProductionInactiveDelay</td><td>125</td><td>Integer</td><td>How long to wait (in ticks) between structure production checks when there is no active production. </td></tr>
<tr><td>StructureProductionActiveDelay</td><td>10</td><td>Integer</td><td>How long to wait (in ticks) between structure production checks ticks when actively building things. </td></tr>
<tr><td>MinimumDefenseRadius</td><td>5</td><td>Integer</td><td>Minimum range at which to build defensive structures near a combat hotspot. </td></tr>
<tr><td>MaximumDefenseRadius</td><td>20</td><td>Integer</td><td>Maximum range at which to build defensive structures near a combat hotspot. </td></tr>
<tr><td>NewProductionCashThreshold</td><td>5000</td><td>Integer</td><td>Try to build another production building if there is too much cash. </td></tr>
<tr><td>IdleBaseUnitsMaximum</td><td>12</td><td>Integer</td><td>Only produce units as long as there are less than this amount of units idling inside the base. </td></tr>
<tr><td>RushAttackScanRadius</td><td>15</td><td>Integer</td><td>Radius in cells around enemy BaseBuilder (Construction Yard) where AI scans for targets to rush. </td></tr>
<tr><td>ProtectUnitScanRadius</td><td>15</td><td>Integer</td><td>Radius in cells around the base that should be scanned for units to be protected. </td></tr>
<tr><td>RallyPointScanRadius</td><td>8</td><td>Integer</td><td>Radius in cells around a factory scanned for rally points by the AI. </td></tr>
<tr><td>MaxBaseRadius</td><td>20</td><td>Integer</td><td>Radius in cells around the center of the base to expand. </td></tr>
<tr><td>UnitQueues</td><td>Vehicle, Infantry, Plane, Ship, Aircraft</td><td>Multiple String</td><td>Production queues AI uses for producing units. </td></tr>
<tr><td>ShouldRepairBuildings</td><td>True</td><td>Boolean</td><td>Should the AI repair its buildings if damaged? </td></tr>
<tr><td>UnitsToBuild</td><td></td><td>Dictionary<String,Real Number></td><td>What units to the AI should build. What % of the total army must be this type of unit. </td></tr>
<tr><td>BuildingFractions</td><td></td><td>Dictionary<String,Real Number></td><td>What buildings to the AI should build. What % of the total base must be this type of building. </td></tr>
<tr><td>UnitsCommonNames</td><td></td><td>Dictionary<String,Multiple String></td><td>Tells the AI what unit types fall under the same common name. </td></tr>
<tr><td>BuildingCommonNames</td><td></td><td>Dictionary<String,Multiple String></td><td>Tells the AI what building types fall under the same common name. </td></tr>
<tr><td>BuildingLimits</td><td></td><td>Dictionary<String,Integer></td><td>What buildings should the AI have max limits n. What is the limit of the building. </td></tr>
<tr><td>PowerDecisions</td><td>(Collection)</td><td>List`1</td><td>Tells the AI how to use its support powers. </td></tr>
</table>

### Aircraft
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>CruiseAltitude</td><td>1280</td><td>1D World Range</td><td></td></tr>
<tr><td>IdealSeparation</td><td>1706</td><td>1D World Range</td><td></td></tr>
<tr><td>Repulsable</td><td>True</td><td>Boolean</td><td>Whether the aircraft can be repulsed. </td></tr>
<tr><td>RepulsionSpeed</td><td>-1</td><td>Integer</td><td>The speed at which the aircraft is repulsed from other aircraft. Specify -1 for normal movement speed. </td></tr>
<tr><td>RepairBuildings</td><td>fix</td><td>Multiple String</td><td></td></tr>
<tr><td>RearmBuildings</td><td>hpad, afld</td><td>Multiple String</td><td></td></tr>
<tr><td>InitialFacing</td><td>128</td><td>Integer</td><td></td></tr>
<tr><td>ROT</td><td>255</td><td>Integer</td><td></td></tr>
<tr><td>Speed</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>LandableTerrainTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>MoveIntoShroud</td><td>True</td><td>Boolean</td><td>Can the actor be ordered to move in to shroud? </td></tr>
</table>

### FlyAwayOnIdle
Leave the map when idle.

### Helicopter
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>LandWhenIdle</td><td>True</td><td>Boolean</td><td>Allow the helicopter land after it has no more commands. </td></tr>
<tr><td>TurnToLand</td><td>False</td><td>Boolean</td><td>Allow the helicopter turn before landing. </td></tr>
<tr><td>LandAltitude</td><td>0</td><td>1D World Range</td><td></td></tr>
<tr><td>AltitudeVelocity</td><td>43</td><td>1D World Range</td><td>How fast the helicopter ascends or descends. </td></tr>
<tr><td>CruiseAltitude</td><td>1280</td><td>1D World Range</td><td></td></tr>
<tr><td>IdealSeparation</td><td>1706</td><td>1D World Range</td><td></td></tr>
<tr><td>Repulsable</td><td>True</td><td>Boolean</td><td>Whether the aircraft can be repulsed. </td></tr>
<tr><td>RepulsionSpeed</td><td>-1</td><td>Integer</td><td>The speed at which the aircraft is repulsed from other aircraft. Specify -1 for normal movement speed. </td></tr>
<tr><td>RepairBuildings</td><td>fix</td><td>Multiple String</td><td></td></tr>
<tr><td>RearmBuildings</td><td>hpad, afld</td><td>Multiple String</td><td></td></tr>
<tr><td>InitialFacing</td><td>128</td><td>Integer</td><td></td></tr>
<tr><td>ROT</td><td>255</td><td>Integer</td><td></td></tr>
<tr><td>Speed</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>LandableTerrainTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>MoveIntoShroud</td><td>True</td><td>Boolean</td><td>Can the actor be ordered to move in to shroud? </td></tr>
</table>

### AttackPlane
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FacingTolerance</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### TargetableAircraft
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>GroundedTargetTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>TargetTypes</td><td></td><td>Multiple String</td><td>Target type. Used for filtering (in)valid targets. </td></tr>
<tr><td>RequiresForceFire</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### AttackHeli
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>FacingTolerance</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>Armaments</td><td>primary, secondary</td><td>Multiple String</td><td>Armament names </td></tr>
<tr><td>Cursor</td><td>attack</td><td>String</td><td></td></tr>
<tr><td>OutsideRangeCursor</td><td>attackoutsiderange</td><td>String</td><td></td></tr>
</table>

### FallsToEarth
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Explosion</td><td>UnitExplode</td><td>String</td><td></td></tr>
<tr><td>Spins</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>Moves</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Velocity</td><td>43</td><td>1D World Range</td><td></td></tr>
</table>

### ReturnOnIdle
Return to a player owned RearmBuildings. If none available, head back to base and circle over it.

### Plane
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MaximumPitch</td><td>28</td><td>1D World Angle</td><td></td></tr>
<tr><td>CruiseAltitude</td><td>1280</td><td>1D World Range</td><td></td></tr>
<tr><td>IdealSeparation</td><td>1706</td><td>1D World Range</td><td></td></tr>
<tr><td>Repulsable</td><td>True</td><td>Boolean</td><td>Whether the aircraft can be repulsed. </td></tr>
<tr><td>RepulsionSpeed</td><td>-1</td><td>Integer</td><td>The speed at which the aircraft is repulsed from other aircraft. Specify -1 for normal movement speed. </td></tr>
<tr><td>RepairBuildings</td><td>fix</td><td>Multiple String</td><td></td></tr>
<tr><td>RearmBuildings</td><td>hpad, afld</td><td>Multiple String</td><td></td></tr>
<tr><td>InitialFacing</td><td>128</td><td>Integer</td><td></td></tr>
<tr><td>ROT</td><td>255</td><td>Integer</td><td></td></tr>
<tr><td>Speed</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>LandableTerrainTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>MoveIntoShroud</td><td>True</td><td>Boolean</td><td>Can the actor be ordered to move in to shroud? </td></tr>
</table>

### RepairableBuilding
Building can be repaired by the repair button.


Requires trait: `Health`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RepairPercent</td><td>20</td><td>Integer</td><td></td></tr>
<tr><td>RepairInterval</td><td>24</td><td>Integer</td><td></td></tr>
<tr><td>RepairStep</td><td>7</td><td>Integer</td><td></td></tr>
<tr><td>RepairBonuses</td><td>100, 150, 175, 200, 220, 240, 260, 280, 300</td><td>Multiple Integer</td><td></td></tr>
<tr><td>IndicatorPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
</table>

### BuildingInfluence
A dictionary of buildings placed on the map. Attach this to the world actor.

### Bib
Requires traits: `Building`, `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>bib</td><td>String</td><td></td></tr>
<tr><td>Palette</td><td>terrain</td><td>String</td><td></td></tr>
<tr><td>HasMinibib</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### LineBuild
Place the second actor in line to build more of the same at once (used for walls).
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>5</td><td>Integer</td><td>The maximum allowed length of the line. </td></tr>
<tr><td>NodeTypes</td><td>wall</td><td>Multiple String</td><td>LineBuildNode 'Types' to attach to. </td></tr>
</table>

### LaysTerrain
Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Template</td><td>0</td><td>UInt16</td><td>The terrain template to place. If the template is PickAny, thenthe actor footprint will be filled with this tile. </td></tr>
<tr><td>TerrainTypes</td><td></td><td>Multiple String</td><td>The terrain types that this template will be placed on </td></tr>
<tr><td>Offset</td><td>0,0</td><td>2D Cell Vector</td><td>Offset relative to the actor TopLeft. Not used if the template is PickAny </td></tr>
</table>

### CustomBuildTimeValue
Overrides the build time calculated by actor value.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Value</td><td>0</td><td>Integer</td><td></td></tr>
</table>

### LineBuildNode
LineBuild actors attach to LineBuildNodes.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Types</td><td>wall</td><td>Multiple String</td><td>This actor is of LineBuild 'NodeType'... </td></tr>
</table>

### GivesBuildableArea
Remove this trait to limit base-walking by cheap or defensive buildings.

### Building
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>TerrainTypes</td><td></td><td>Multiple String</td><td>Where you are allowed to place the building (Water, Clear, ...) </td></tr>
<tr><td>Adjacent</td><td>2</td><td>Integer</td><td>The range to the next building it can be constructed. Set it higher for walls. </td></tr>
<tr><td>Footprint</td><td>x</td><td>String</td><td>x means space it blocks, _ is a part that is passable by actors. </td></tr>
<tr><td>Dimensions</td><td>1,1</td><td>2D Cell Vector</td><td></td></tr>
<tr><td>RequiresBaseProvider</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>AllowInvalidPlacement</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>BuildSounds</td><td>placbldg.aud, build5.aud</td><td>Multiple String</td><td></td></tr>
<tr><td>UndeploySounds</td><td>cashturn.aud</td><td>Multiple String</td><td></td></tr>
</table>

### CustomSellValue
Allow a non-standard sell/repair value to avoid buy-sell exploits.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Value</td><td>0</td><td>Integer</td><td></td></tr>
</table>

### ShakeOnDeath
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Intensity</td><td>10</td><td>Integer</td><td></td></tr>
</table>

### SoundOnDamageTransition
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>DamagedSound</td><td></td><td>String</td><td></td></tr>
<tr><td>DestroyedSound</td><td></td><td>String</td><td></td></tr>
</table>

### BaseProvider
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>Cooldown</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>InitialDelay</td><td>0</td><td>Integer</td><td></td></tr>
</table>

### DuplicateUnitCrateAction
Creates duplicates of the actor that collects the crate.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MaxAmount</td><td>2</td><td>Integer</td><td>The maximum number of duplicates to make. </td></tr>
<tr><td>MinAmount</td><td>1</td><td>Integer</td><td>The minimum number of duplicates to make. Overrules MaxDuplicatesWorth. </td></tr>
<tr><td>MaxDuplicateValue</td><td>-1</td><td>Integer</td><td>The maximum total value allowed for the duplicates. Duplication stops if the total worth will exceed this number. -1 = no limit </td></tr>
<tr><td>MaxRadius</td><td>4</td><td>Integer</td><td>The maximum radius (in cells) that duplicates can be spawned. </td></tr>
<tr><td>ValidTargets</td><td>Ground, Water</td><td>Multiple String</td><td>The list of unit target types we are allowed to duplicate. </td></tr>
<tr><td>ValidRaces</td><td></td><td>Multiple String</td><td>Which races this crate action can occur for. </td></tr>
<tr><td>Owner</td><td></td><td>String</td><td>Is the new duplicates given to a specific owner, regardless of whom collected it? </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### GrantUpgradeCrateAction
Grants an upgrade to the collector.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Upgrades</td><td></td><td>Multiple String</td><td>The upgrades to apply. </td></tr>
<tr><td>Duration</td><td>0</td><td>Integer</td><td>Duration of the upgrade (in ticks). Set to 0 for a permanent upgrade. </td></tr>
<tr><td>Range</td><td>3</td><td>1D World Range</td><td>The range to search for extra collectors in. Extra collectors will also be granted the crate action. </td></tr>
<tr><td>MaxExtraCollectors</td><td>4</td><td>Integer</td><td>The maximum number of extra collectors to grant the crate action to. -1 = no limit </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### GiveMcvCrateAction
Spawns units when collected.
Adjust selection shares when player has no base.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>NoBaseSelectionShares</td><td>1000</td><td>Integer</td><td>The selection shares to use if the collector has no base. </td></tr>
<tr><td>Units</td><td></td><td>Multiple String</td><td>The list of units to spawn. </td></tr>
<tr><td>ValidRaces</td><td></td><td>Multiple String</td><td>Races that are allowed to trigger this action </td></tr>
<tr><td>Owner</td><td></td><td>String</td><td>Override the owner of the newly spawned unit: e.g. Creeps or Neutral </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### GiveUnitCrateAction
Spawns units when collected.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Units</td><td></td><td>Multiple String</td><td>The list of units to spawn. </td></tr>
<tr><td>ValidRaces</td><td></td><td>Multiple String</td><td>Races that are allowed to trigger this action </td></tr>
<tr><td>Owner</td><td></td><td>String</td><td>Override the owner of the newly spawned unit: e.g. Creeps or Neutral </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### HealUnitsCrateAction
Heals all actors that belong to the owner of the collector.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### SupportPowerCrateAction
Gives a supportpower to the collector.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Proxy</td><td></td><td>String</td><td>Which proxy actor, which grants the support power, to spawn. </td></tr>
<tr><td>SelectionShares</td><td>10</td><td>Integer</td><td>Chance of getting this crate, assuming the collector is compatible. </td></tr>
<tr><td>Effect</td><td></td><td>String</td><td>An animation defined in sequence yaml(s) to draw. </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Palette to draw the animation in. </td></tr>
<tr><td>Notification</td><td></td><td>String</td><td>Audio clip to play when the crate is collected. </td></tr>
<tr><td>TimeDelay</td><td>0</td><td>Integer</td><td>The earliest time (in ticks) that this crate action can occur on. </td></tr>
<tr><td>Prerequisites</td><td></td><td>Multiple String</td><td>Only allow this crate action when the collector has these prerequisites </td></tr>
<tr><td>ExcludedActorTypes</td><td></td><td>Multiple String</td><td>Actor types that this crate action will not occur for. </td></tr>
</table>

### GpsDot
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>String</td><td>Infantry</td><td>String</td><td></td></tr>
<tr><td>IndicatorPalettePrefix</td><td>player</td><td>String</td><td></td></tr>
</table>

### InfiltrateForPowerOutage
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Duration</td><td>750</td><td>Integer</td><td></td></tr>
</table>

### InfiltrateForExploration

### InfiltrateForSupportPower
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Proxy</td><td></td><td>String</td><td></td></tr>
</table>

### InfiltrateForCash
This structure can be infiltrated causing funds to be stolen.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Percentage</td><td>50</td><td>Integer</td><td></td></tr>
<tr><td>Minimum</td><td>500</td><td>Integer</td><td></td></tr>
<tr><td>SoundToVictim</td><td>credit1.aud</td><td>String</td><td></td></tr>
</table>

### Infiltrates
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Types</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### PathFinder
Calculates routes for mobile units based on the A* search algorithm.
 Attach this to the world actor.

### Mobile
Unit is able to move.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>TerrainSpeeds</td><td></td><td>Dictionary<String,TerrainInfo></td><td>Set Water: 0 for ground units and lower the value on rough terrain. </td></tr>
<tr><td>Crushes</td><td></td><td>Multiple String</td><td>e.g. crate, wall, infantry </td></tr>
<tr><td>WaitAverage</td><td>5</td><td>Integer</td><td></td></tr>
<tr><td>WaitSpread</td><td>2</td><td>Integer</td><td></td></tr>
<tr><td>InitialFacing</td><td>128</td><td>Integer</td><td></td></tr>
<tr><td>ROT</td><td>255</td><td>Integer</td><td>Rate of Turning </td></tr>
<tr><td>Speed</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>OnRails</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>SharesCell</td><td>False</td><td>Boolean</td><td>Allow multiple (infantry) units in one cell. </td></tr>
<tr><td>MoveIntoShroud</td><td>True</td><td>Boolean</td><td>Can the actor be ordered to move in to shroud? </td></tr>
<tr><td>TilesetTerrainInfo</td><td></td><td>Cached<TileSet,Multiple TerrainInfo></td><td></td></tr>
<tr><td>TilesetMovementClass</td><td></td><td>Cached<TileSet,Integer></td><td></td></tr>
</table>

### Power
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Amount</td><td>0</td><td>Integer</td><td>If negative, it will drain power. If positive, it will provide power. </td></tr>
</table>

### ScalePowerWithHealth
Scale power amount with the current health.


Requires traits: `Health`, `Power`.

### RequiresPower

### AffectedByPowerOutage

### PowerManager
Requires trait: `DeveloperMode`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>AdviceInterval</td><td>250</td><td>Integer</td><td></td></tr>
</table>

### CanPowerDown
The player can disable the power individually on this actor.


Requires trait: `Power`.

### RenderBuildingTurreted
Requires traits: `Building`, `Turreted`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### RenderBuildingCharge
Used for tesla coil and obelisk.


Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ChargeAudio</td><td></td><td>String</td><td>Sound to play when building charges. </td></tr>
<tr><td>ChargeSequence</td><td>active</td><td>String</td><td>Sequence to use for building charge animation. </td></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithBuildingPlacedAnimation
Changes the animation when the actor constructed a building.


Requires trait: `RenderSimple`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>build</td><td>String</td><td>Sequence name to use </td></tr>
</table>

### WithActiveAnimation
Replaces the idle animation of a building.


Requires trait: `RenderBuilding`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>active</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Interval</td><td>750</td><td>Integer</td><td></td></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### RenderDisguise
Requires trait: `Disguise`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MinIdleWaitTicks</td><td>30</td><td>Integer</td><td></td></tr>
<tr><td>MaxIdleWaitTicks</td><td>110</td><td>Integer</td><td></td></tr>
<tr><td>MoveAnimation</td><td>run</td><td>String</td><td></td></tr>
<tr><td>AttackAnimation</td><td>shoot</td><td>String</td><td></td></tr>
<tr><td>IdleAnimations</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>StandAnimations</td><td>stand</td><td>Multiple String</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithRotor
Displays a helicopter rotor overlay.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>rotor</td><td>String</td><td>Sequence name to use when flying </td></tr>
<tr><td>GroundSequence</td><td>slow-rotor</td><td>String</td><td>Sequence name to use when landed </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Id</td><td>rotor</td><td>String</td><td>Change this when using this trait multiple times on the same actor. </td></tr>
</table>

### WithTurret
Renders turrets for units with the Turreted trait.


Requires traits: `RenderSprites`, `Turreted`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>turret</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>AimSequence</td><td></td><td>String</td><td>Sequence name to use when prepared to fire </td></tr>
<tr><td>Turret</td><td>primary</td><td>String</td><td>Turreted 'Turret' key to display </td></tr>
<tr><td>Recoils</td><td>True</td><td>Boolean</td><td>Render recoil </td></tr>
</table>

### WithShadow
Clones the aircraft sprite with another palette below it.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Palette</td><td>shadow</td><td>String</td><td></td></tr>
</table>

### RenderUnit
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithRepairOverlay
Displays an overlay when the building is being repaired by the player.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>active</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>IsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom palette is a player palette BaseName </td></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### WithCrateBody
Renders crates with both water and land variants.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Images</td><td>crate</td><td>Multiple String</td><td></td></tr>
<tr><td>XmasImages</td><td></td><td>Multiple String</td><td>Easteregg sequences to use in december. </td></tr>
</table>

### RenderBuildingWarFactory
Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithBarrel
Renders barrels for units with the Turreted trait.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>barrel</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Armament</td><td>primary</td><td>String</td><td>Armament to use for recoil </td></tr>
<tr><td>Barrel</td><td>first</td><td>String</td><td>Turreted 'Barrel' key to display </td></tr>
<tr><td>LocalOffset</td><td>0,0,0</td><td>3D World Vector</td><td>Visual offset </td></tr>
</table>

### RenderUnitReload
Requires traits: `Armament`, `AttackBase`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Armament</td><td>primary</td><td>String</td><td>Armament name </td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### RenderNameTag
Displays the player name above the unit
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MaxLength</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>Font</td><td>TinyBold</td><td>String</td><td></td></tr>
</table>

### RenderSimple
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### RenderEditorOnly
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithHarvestAnimation
Displays an overlay whenever resources are harvested by the actor.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>harvest</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
</table>

### RenderBuilding
Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### RenderInfantry
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MinIdleWaitTicks</td><td>30</td><td>Integer</td><td></td></tr>
<tr><td>MaxIdleWaitTicks</td><td>110</td><td>Integer</td><td></td></tr>
<tr><td>MoveAnimation</td><td>run</td><td>String</td><td></td></tr>
<tr><td>AttackAnimation</td><td>shoot</td><td>String</td><td></td></tr>
<tr><td>IdleAnimations</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>StandAnimations</td><td>stand</td><td>Multiple String</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### RenderBuildingWall
Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Type</td><td>wall</td><td>String</td><td></td></tr>
<tr><td>Sequence</td><td>idle</td><td>String</td><td></td></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### RenderFlare
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithBuildingExplosion
Display explosions over the building footprint when it is destroyed.


Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>building</td><td>String</td><td>Explosion sequence name to use </td></tr>
<tr><td>Palette</td><td>effect</td><td>String</td><td>Custom palette name </td></tr>
</table>

### RenderLandingCraft
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>OpenTerrainTypes</td><td>Clear</td><td>Multiple String</td><td></td></tr>
<tr><td>OpenAnim</td><td>open</td><td>String</td><td></td></tr>
<tr><td>UnloadAnim</td><td>unload</td><td>String</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### RenderVoxels
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>NormalsPalette</td><td>normals</td><td>String</td><td></td></tr>
<tr><td>Scale</td><td>10</td><td>Real Number</td><td>Change the image size. </td></tr>
<tr><td>LightPitch</td><td>142</td><td>1D World Angle</td><td></td></tr>
<tr><td>LightYaw</td><td>682</td><td>1D World Angle</td><td></td></tr>
<tr><td>LightAmbientColor</td><td>0.6, 0.6, 0.6</td><td>Multiple Real Number</td><td></td></tr>
<tr><td>LightDiffuseColor</td><td>0.4, 0.4, 0.4</td><td>Multiple Real Number</td><td></td></tr>
</table>

### WithResources
Displays the fill status of PlayerResources with an extra sprite overlay on the actor.


Requires trait: `RenderSimple`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>resources</td><td>String</td><td>Sequence name to use </td></tr>
</table>

### WithVoxelBody
Also returns a default selection size that is calculated automatically from the voxel dimensions.


Requires trait: `RenderVoxels`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>idle</td><td>String</td><td></td></tr>
</table>

### WithDeathAnimation
This actor has a death animation.


Requires trait: `RenderSimple`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>DeathSequence</td><td>die</td><td>String</td><td>Sequence to play when this actor is killed by a warhead. </td></tr>
<tr><td>DeathSequencePalette</td><td>player</td><td>String</td><td></td></tr>
<tr><td>DeathPaletteIsPlayerPalette</td><td>True</td><td>Boolean</td><td>Custom death animation palette is a player palette BaseName </td></tr>
<tr><td>UseDeathTypeSuffix</td><td>True</td><td>Boolean</td><td>Should DeathType-specific sequences be used (sequence name = DeathSequence + DeathType). </td></tr>
<tr><td>CrushedSequence</td><td>die-crushed</td><td>String</td><td>Sequence to play when this actor is crushed. </td></tr>
<tr><td>CrushedSequencePalette</td><td>effect</td><td>String</td><td></td></tr>
<tr><td>CrushedPaletteIsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom crushed animation palette is a player palette BaseName </td></tr>
</table>

### RenderHarvester
Requires trait: `Harvester`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ImagesByFullness</td><td>harv</td><td>Multiple String</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithMakeAnimation
Requires traits: `Building`, `RenderBuilding`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>make</td><td>String</td><td>Sequence name to use </td></tr>
</table>

### WithVoxelBarrel
Requires trait: `RenderVoxels`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>barrel</td><td>String</td><td>Voxel sequence name to use </td></tr>
<tr><td>Armament</td><td>primary</td><td>String</td><td>Armament to use for recoil </td></tr>
<tr><td>LocalOffset</td><td>0,0,0</td><td>3D World Vector</td><td>Visual offset </td></tr>
</table>

### WithIdleOverlay
Renders a decorative animation on units and buildings.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>idle-overlay</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>Offset</td><td>0,0,0</td><td>3D World Vector</td><td>Position relative to body </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>IsPlayerPalette</td><td>False</td><td>Boolean</td><td>Custom palette is a player palette BaseName </td></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### RenderBuildingSilo
Requires trait: `Building`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithSmoke
Renders an overlay when the actor is taking heavy damage.


Requires trait: `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>smoke_m</td><td>String</td><td>Needs to define "idle", "loop" and "end" sub-sequences. </td></tr>
</table>

### WithRepairAnimation
Replaces the building animation when it repairs a unit.


Requires trait: `RenderBuilding`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>active</td><td>String</td><td>Sequence name to use </td></tr>
<tr><td>PauseOnLowPower</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### WithVoxelTurret
Requires traits: `RenderVoxels`, `Turreted`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Sequence</td><td>turret</td><td>String</td><td>Voxel sequence name to use </td></tr>
<tr><td>Turret</td><td>primary</td><td>String</td><td>Turreted 'Turret' key to display </td></tr>
</table>

### WithMuzzleFlash
Renders the MuzzleSequence from the Armament trait.


Requires traits: `Armament`, `AttackBase`, `RenderSprites`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>IgnoreOffset</td><td>False</td><td>Boolean</td><td>Ignore the weapon position, and always draw relative to the center of the actor </td></tr>
</table>

### RenderSprites
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### WithDeliveryAnimation
Building animation to play when ProductionAirdrop is used to deliver units.


Requires trait: `RenderBuilding`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>ActiveSequence</td><td>active</td><td>String</td><td></td></tr>
<tr><td>IdleSequence</td><td>idle</td><td>String</td><td></td></tr>
</table>

### RenderGunboat
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Turret</td><td>primary</td><td>String</td><td>Turreted 'Turret' key to display </td></tr>
<tr><td>LeftSequence</td><td>left</td><td>String</td><td></td></tr>
<tr><td>RightSequence</td><td>right</td><td>String</td><td></td></tr>
<tr><td>WakeLeftSequence</td><td>wake-left</td><td>String</td><td></td></tr>
<tr><td>WakeRightSequence</td><td>wake-right</td><td>String</td><td></td></tr>
<tr><td>Image</td><td></td><td>String</td><td>Defaults to the actor name. </td></tr>
<tr><td>Palette</td><td></td><td>String</td><td>Custom palette name </td></tr>
<tr><td>PlayerPalette</td><td>player</td><td>String</td><td>Custom PlayerColorPalette: BaseName </td></tr>
<tr><td>Scale</td><td>1</td><td>Real Number</td><td>Change the sprite image size. </td></tr>
</table>

### ScriptTriggers
Allows map scripts to attach triggers to this actor via the Triggers global.

### LuaScript
Part of the new Lua API.


Requires trait: `SpawnMapActors`.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Scripts</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### RevealsShroud
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>0</td><td>1D World Range</td><td></td></tr>
</table>

### Selectable
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Selectable</td><td>True</td><td>Boolean</td><td></td></tr>
<tr><td>Priority</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>Bounds</td><td></td><td>Multiple Integer</td><td></td></tr>
<tr><td>Voice</td><td></td><td>String</td><td></td></tr>
</table>

### Health
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>HP</td><td>0</td><td>Integer</td><td>HitPoints </td></tr>
<tr><td>Radius</td><td>426</td><td>1D World Range</td><td>Physical size of the unit used for damage calculations.  Impacts within this radius apply full damage </td></tr>
<tr><td>NotifyAppliedDamage</td><td>True</td><td>Boolean</td><td>Don't trigger interfaces such as AnnounceOnKill. </td></tr>
</table>

### EditorTilesetFilter
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RequireTilesets</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>ExcludeTilesets</td><td></td><td>Multiple String</td><td></td></tr>
</table>

### Armor
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Type</td><td></td><td>String</td><td></td></tr>
</table>

### Shroud
Required for shroud and fog visibility checks. Add this to the player actor.

### ActorMap
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>BinSize</td><td>10</td><td>Integer</td><td>Size of partition bins (cells) </td></tr>
</table>

### ResourceType
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>EditorSprite</td><td></td><td>String</td><td></td></tr>
<tr><td>Variants</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>Palette</td><td>terrain</td><td>String</td><td></td></tr>
<tr><td>Sequence</td><td>resources</td><td>String</td><td></td></tr>
<tr><td>ResourceType</td><td>1</td><td>Integer</td><td></td></tr>
<tr><td>ValuePerUnit</td><td>0</td><td>Integer</td><td></td></tr>
<tr><td>MaxDensity</td><td>10</td><td>Integer</td><td></td></tr>
<tr><td>Name</td><td></td><td>String</td><td></td></tr>
<tr><td>TerrainType</td><td>Ore</td><td>String</td><td></td></tr>
<tr><td>AllowedTerrainTypes</td><td></td><td>Multiple String</td><td></td></tr>
<tr><td>AllowUnderActors</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>AllowUnderBuildings</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>PipColor</td><td>Yellow</td><td>PipType</td><td></td></tr>
</table>

### ScreenShaker
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>MinMultiplier</td><td>-3,-3</td><td>2D Real Number</td><td></td></tr>
<tr><td>MaxMultiplier</td><td>3,3</td><td>2D Real Number</td><td></td></tr>
</table>

### ScreenMap
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>BinSize</td><td>250</td><td>Integer</td><td>Size of partition bins (world pixels) </td></tr>
</table>

### Country
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Name</td><td></td><td>String</td><td>This is the name exposed to the players. </td></tr>
<tr><td>Race</td><td></td><td>String</td><td>This is the internal name for owner checks. </td></tr>
<tr><td>Selectable</td><td>True</td><td>Boolean</td><td></td></tr>
</table>

### DrawLineToTarget
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Ticks</td><td>60</td><td>Integer</td><td></td></tr>
</table>

### RejectsOrders
Can be used to make a unit partly uncontrollable by the player.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Except</td><td></td><td>Multiple String</td><td>Possible values include Attack, AttackMove, Guard, Move. </td></tr>
</table>

### DeveloperMode
Attach this to the player actor.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Cash</td><td>20000</td><td>Integer</td><td></td></tr>
<tr><td>ResourceGrowth</td><td>100</td><td>Integer</td><td></td></tr>
<tr><td>FastBuild</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>FastCharge</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>DisableShroud</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>PathDebug</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>UnlimitedPower</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>BuildAnywhere</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>ShowCombatGeometry</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>ShowDebugGeometry</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### FrozenActorLayer
Required for FrozenUnderFog to work. Attach this to the player actor.

### PlayerResources
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>SelectableCash</td><td>2500, 5000, 10000, 20000</td><td>Multiple Integer</td><td></td></tr>
<tr><td>DefaultCash</td><td>5000</td><td>Integer</td><td></td></tr>
<tr><td>AdviceInterval</td><td>250</td><td>Integer</td><td></td></tr>
</table>

### PlayerColorPalette
Add this to the Player actor definition.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>BasePalette</td><td></td><td>String</td><td>The name of the palette to base off. </td></tr>
<tr><td>BaseName</td><td>player</td><td>String</td><td>The prefix for the resulting player palettes </td></tr>
<tr><td>RemapIndex</td><td></td><td>Multiple Integer</td><td>Remap these indices to player colors. </td></tr>
<tr><td>Ramp</td><td>0.05</td><td>Real Number</td><td>Luminosity range to span. </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td>Allow palette modifiers to change the palette. </td></tr>
</table>

### FixedColorPalette
Add this to the World actor definition.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Base</td><td>terrain</td><td>String</td><td>The name of the palette to base off. </td></tr>
<tr><td>Name</td><td>resources</td><td>String</td><td>The name of the resulting palette </td></tr>
<tr><td>RemapIndex</td><td></td><td>Multiple Integer</td><td>Remap these indices to pre-defined colors. </td></tr>
<tr><td>Color</td><td>0,0,0</td><td>HSLColor</td><td>The fixed color to remap. </td></tr>
<tr><td>Ramp</td><td>0.05</td><td>Real Number</td><td>Luminosity range to span. </td></tr>
<tr><td>AllowModifiers</td><td>True</td><td>Boolean</td><td>Allow palette modifiers to change the palette. </td></tr>
</table>

### PlayerHighlightPalette
Add this to the Player actor definition.
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>BaseName</td><td>highlight</td><td>String</td><td>The prefix for the resulting player palettes </td></tr>
</table>

### DebugPauseState
Checks for pause related desyncs. Attach this to the world actor.

### EditorAppearance
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>RelativeToTopLeft</td><td>False</td><td>Boolean</td><td></td></tr>
<tr><td>UseTerrainPalette</td><td>False</td><td>Boolean</td><td></td></tr>
</table>

### CreatesShroud
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Range</td><td>0</td><td>1D World Range</td><td></td></tr>
</table>

### BodyOrientation
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>QuantizedFacings</td><td>-1</td><td>Integer</td><td>Number of facings for gameplay calculations. -1 indicates auto-detection from another trait </td></tr>
<tr><td>CameraPitch</td><td>113</td><td>1D World Angle</td><td>Camera pitch for rotation calculations </td></tr>
</table>

### ValidateOrder
Used to detect exploits. Attach this to the world actor.

### SelectionDecorations
<table>
<tr><th>Property</th><th>Default Value</th><th>Type</th><th>Description</th></tr>
<tr><td>Palette</td><td>chrome</td><td>String</td><td></td></tr>
</table>
